// _gen/core/runtime.asdl.h is generated by asdl_main.py

#ifndef RUNTIME_ASDL
#define RUNTIME_ASDL

#include <cstdint>

#include "mycpp/runtime.h"
#include "_gen/asdl/hnode.asdl.h"
using hnode_asdl::hnode_t;

#include "_gen/frontend/id_kind.asdl.h"
using id_kind_asdl::Id_t;

namespace syntax_asdl { class ArgList; class command_t; class re_t; class redir_loc_t; class BraceGroup; class Token; class proc_sig_t; }

namespace runtime_asdl {

class assign_arg;
class cmd_value_t;
class part_value_t;
class value_t;
class a_index_t;
class VTestPlace;
class VarSubState;
class cell;
class lvalue_t;
class redirect_arg_t;
class redirect;
class Proc;
class StatusArray;
class CommandStatus;
class wait_status_t;
class trace_t;
class hay_node;

namespace cmd_value_e {
  const int Argv = 1;
  const int Assign = 2;
};

const char* cmd_value_str(int tag);

class cmd_value_t {
 protected:
  cmd_value_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(cmd_value_t)
};

class cmd_value__Argv : public cmd_value_t {
 public:
  cmd_value__Argv()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(cmd_value_e::Argv),
                      field_mask(), sizeof(cmd_value__Argv)),
        argv(NewList<Str*>()),
        arg_spids(NewList<int>()),
        typed_args(nullptr) {
  }

  cmd_value__Argv(List<Str*>* argv, List<int>* arg_spids, syntax_asdl::ArgList*
                  typed_args)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(cmd_value_e::Argv),
                      field_mask(), sizeof(cmd_value__Argv)),
        argv(argv),
        arg_spids(arg_spids),
        typed_args(typed_args) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Str*>* argv;
  List<int>* arg_spids;
  syntax_asdl::ArgList* typed_args;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(cmd_value__Argv, argv))
         | maskbit(offsetof(cmd_value__Argv, arg_spids))
         | maskbit(offsetof(cmd_value__Argv, typed_args));
  }

  DISALLOW_COPY_AND_ASSIGN(cmd_value__Argv)
};

class cmd_value__Assign : public cmd_value_t {
 public:
  cmd_value__Assign()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(cmd_value_e::Assign),
                      field_mask(), sizeof(cmd_value__Assign)),
        builtin_id(-1),
        argv(NewList<Str*>()),
        arg_spids(NewList<int>()),
        pairs(NewList<assign_arg*>()) {
  }

  cmd_value__Assign(int builtin_id, List<Str*>* argv, List<int>* arg_spids,
                    List<assign_arg*>* pairs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(cmd_value_e::Assign),
                      field_mask(), sizeof(cmd_value__Assign)),
        builtin_id(builtin_id),
        argv(argv),
        arg_spids(arg_spids),
        pairs(pairs) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int builtin_id;
  List<Str*>* argv;
  List<int>* arg_spids;
  List<assign_arg*>* pairs;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(cmd_value__Assign, argv))
         | maskbit(offsetof(cmd_value__Assign, arg_spids))
         | maskbit(offsetof(cmd_value__Assign, pairs));
  }

  DISALLOW_COPY_AND_ASSIGN(cmd_value__Assign)
};

namespace cmd_value {
  typedef cmd_value__Argv Argv;
  typedef cmd_value__Assign Assign;
}

namespace part_value_e {
  const int String = 1;
  const int Array = 2;
  const int ExtGlob = 3;
};

const char* part_value_str(int tag);

class part_value_t {
 protected:
  part_value_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(part_value_t)
};

class part_value__String : public part_value_t {
 public:
  part_value__String()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::String),
                      field_mask(), sizeof(part_value__String)),
        s(StrFromC("")),
        quoted(false),
        do_split(false) {
  }

  part_value__String(Str* s, bool quoted, bool do_split)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::String),
                      field_mask(), sizeof(part_value__String)),
        s(s),
        quoted(quoted),
        do_split(do_split) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* s;
  bool quoted;
  bool do_split;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(part_value__String, s));
  }

  DISALLOW_COPY_AND_ASSIGN(part_value__String)
};

class part_value__Array : public part_value_t {
 public:
  part_value__Array()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::Array),
                      field_mask(), sizeof(part_value__Array)),
        strs(NewList<Str*>()) {
  }

  part_value__Array(List<Str*>* strs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::Array),
                      field_mask(), sizeof(part_value__Array)),
        strs(strs) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Str*>* strs;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(part_value__Array, strs));
  }

  DISALLOW_COPY_AND_ASSIGN(part_value__Array)
};

class part_value__ExtGlob : public part_value_t {
 public:
  part_value__ExtGlob()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::ExtGlob),
                      field_mask(), sizeof(part_value__ExtGlob)),
        part_vals(NewList<part_value_t*>()) {
  }

  part_value__ExtGlob(List<part_value_t*>* part_vals)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(part_value_e::ExtGlob),
                      field_mask(), sizeof(part_value__ExtGlob)),
        part_vals(part_vals) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<part_value_t*>* part_vals;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(part_value__ExtGlob, part_vals));
  }

  DISALLOW_COPY_AND_ASSIGN(part_value__ExtGlob)
};

namespace part_value {
  typedef part_value__String String;
  typedef part_value__Array Array;
  typedef part_value__ExtGlob ExtGlob;
}

namespace value_e {
  const int Undef = 1;
  const int Str = 2;
  const int Int = 3;
  const int MaybeStrArray = 4;
  const int AssocArray = 5;
  const int Bool = 6;
  const int Float = 7;
  const int Eggex = 8;
  const int Block = 9;
  const int Obj = 10;
};

const char* value_str(int tag);

class value_t {
 protected:
  value_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(value_t)
};

class value__Undef : public value_t {
 public:
  value__Undef()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Undef),
                      kZeroMask, sizeof(value__Undef)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(value__Undef)
};

class value__Str : public value_t {
 public:
  value__Str()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Str),
                      field_mask(), sizeof(value__Str)),
        s(StrFromC("")) {
  }

  value__Str(Str* s)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Str),
                      field_mask(), sizeof(value__Str)),
        s(s) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* s;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__Str, s));
  }

  DISALLOW_COPY_AND_ASSIGN(value__Str)
};

class value__Int : public value_t {
 public:
  value__Int()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Int),
                      kZeroMask, sizeof(value__Int)),
        i(-1) {
  }

  value__Int(int i)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Int),
                      kZeroMask, sizeof(value__Int)),
        i(i) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int i;

  DISALLOW_COPY_AND_ASSIGN(value__Int)
};

class value__MaybeStrArray : public value_t {
 public:
  value__MaybeStrArray()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::MaybeStrArray),
                      field_mask(), sizeof(value__MaybeStrArray)),
        strs(NewList<Str*>()) {
  }

  value__MaybeStrArray(List<Str*>* strs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::MaybeStrArray),
                      field_mask(), sizeof(value__MaybeStrArray)),
        strs(strs) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Str*>* strs;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__MaybeStrArray, strs));
  }

  DISALLOW_COPY_AND_ASSIGN(value__MaybeStrArray)
};

class value__AssocArray : public value_t {
 public:
  value__AssocArray()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::AssocArray),
                      field_mask(), sizeof(value__AssocArray)),
        d(NewDict<Str*, Str*>()) {
  }

  value__AssocArray(Dict<Str*, Str*>* d)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::AssocArray),
                      field_mask(), sizeof(value__AssocArray)),
        d(d) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Dict<Str*, Str*>* d;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__AssocArray, d));
  }

  DISALLOW_COPY_AND_ASSIGN(value__AssocArray)
};

class value__Bool : public value_t {
 public:
  value__Bool()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Bool),
                      kZeroMask, sizeof(value__Bool)),
        b(false) {
  }

  value__Bool(bool b)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Bool),
                      kZeroMask, sizeof(value__Bool)),
        b(b) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool b;

  DISALLOW_COPY_AND_ASSIGN(value__Bool)
};

class value__Float : public value_t {
 public:
  value__Float()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Float),
                      kZeroMask, sizeof(value__Float)),
        f(0.0) {
  }

  value__Float(double f)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Float),
                      kZeroMask, sizeof(value__Float)),
        f(f) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  double f;

  DISALLOW_COPY_AND_ASSIGN(value__Float)
};

class value__Eggex : public value_t {
 public:
  value__Eggex()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Eggex),
                      field_mask(), sizeof(value__Eggex)),
        expr(nullptr),
        as_ere(StrFromC("")) {
  }

  value__Eggex(syntax_asdl::re_t* expr, Str* as_ere)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Eggex),
                      field_mask(), sizeof(value__Eggex)),
        expr(expr),
        as_ere(as_ere) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  syntax_asdl::re_t* expr;
  Str* as_ere;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__Eggex, expr))
         | maskbit(offsetof(value__Eggex, as_ere));
  }

  DISALLOW_COPY_AND_ASSIGN(value__Eggex)
};

class value__Block : public value_t {
 public:
  value__Block()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Block),
                      field_mask(), sizeof(value__Block)),
        body(nullptr) {
  }

  value__Block(syntax_asdl::command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Block),
                      field_mask(), sizeof(value__Block)),
        body(body) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  syntax_asdl::command_t* body;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__Block, body));
  }

  DISALLOW_COPY_AND_ASSIGN(value__Block)
};

class value__Obj : public value_t {
 public:
  value__Obj()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Obj),
                      field_mask(), sizeof(value__Obj)),
        obj(nullptr) {
  }

  value__Obj(void* obj)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(value_e::Obj),
                      field_mask(), sizeof(value__Obj)),
        obj(obj) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  void* obj;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(value__Obj, obj));
  }

  DISALLOW_COPY_AND_ASSIGN(value__Obj)
};

namespace value {
  typedef value__Undef Undef;
  typedef value__Str Str;
  typedef value__Int Int;
  typedef value__MaybeStrArray MaybeStrArray;
  typedef value__AssocArray AssocArray;
  typedef value__Bool Bool;
  typedef value__Float Float;
  typedef value__Eggex Eggex;
  typedef value__Block Block;
  typedef value__Obj Obj;
}

namespace a_index_e {
  const int Str = 1;
  const int Int = 2;
};

const char* a_index_str(int tag);

class a_index_t {
 protected:
  a_index_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(a_index_t)
};

class a_index__Str : public a_index_t {
 public:
  a_index__Str()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(a_index_e::Str),
                      field_mask(), sizeof(a_index__Str)),
        s(StrFromC("")) {
  }

  a_index__Str(Str* s)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(a_index_e::Str),
                      field_mask(), sizeof(a_index__Str)),
        s(s) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* s;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(a_index__Str, s));
  }

  DISALLOW_COPY_AND_ASSIGN(a_index__Str)
};

class a_index__Int : public a_index_t {
 public:
  a_index__Int()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(a_index_e::Int),
                      kZeroMask, sizeof(a_index__Int)),
        i(-1) {
  }

  a_index__Int(int i)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(a_index_e::Int),
                      kZeroMask, sizeof(a_index__Int)),
        i(i) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int i;

  DISALLOW_COPY_AND_ASSIGN(a_index__Int)
};

namespace a_index {
  typedef a_index__Str Str;
  typedef a_index__Int Int;
}

enum class scope_e {
  Parent = 1,
  Shopt = 2,
  Dynamic = 3,
  LocalOrGlobal = 4,
  LocalOnly = 5,
  GlobalOnly = 6,
};
typedef scope_e scope_t;

const char* scope_str(scope_e tag);

namespace lvalue_e {
  const int Named = 1;
  const int Indexed = 2;
  const int Keyed = 3;
  const int ObjIndex = 4;
  const int ObjAttr = 5;
};

const char* lvalue_str(int tag);

class lvalue_t {
 protected:
  lvalue_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(lvalue_t)
};

class lvalue__Named : public lvalue_t {
 public:
  lvalue__Named()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Named),
                      field_mask(), sizeof(lvalue__Named)),
        name(StrFromC("")),
        spids(NewList<int>()) {
  }

  lvalue__Named(Str* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Named),
                      field_mask(), sizeof(lvalue__Named)),
        name(name),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(lvalue__Named, name))
         | maskbit(offsetof(lvalue__Named, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(lvalue__Named)
};

class lvalue__Indexed : public lvalue_t {
 public:
  lvalue__Indexed()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Indexed),
                      field_mask(), sizeof(lvalue__Indexed)),
        name(StrFromC("")),
        index(-1),
        spids(NewList<int>()) {
  }

  lvalue__Indexed(Str* name, int index)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Indexed),
                      field_mask(), sizeof(lvalue__Indexed)),
        name(name),
        index(index),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  int index;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(lvalue__Indexed, name))
         | maskbit(offsetof(lvalue__Indexed, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(lvalue__Indexed)
};

class lvalue__Keyed : public lvalue_t {
 public:
  lvalue__Keyed()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Keyed),
                      field_mask(), sizeof(lvalue__Keyed)),
        name(StrFromC("")),
        key(StrFromC("")),
        spids(NewList<int>()) {
  }

  lvalue__Keyed(Str* name, Str* key)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::Keyed),
                      field_mask(), sizeof(lvalue__Keyed)),
        name(name),
        key(key),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  Str* key;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(lvalue__Keyed, name))
         | maskbit(offsetof(lvalue__Keyed, key))
         | maskbit(offsetof(lvalue__Keyed, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(lvalue__Keyed)
};

class lvalue__ObjIndex : public lvalue_t {
 public:
  lvalue__ObjIndex()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::ObjIndex),
                      field_mask(), sizeof(lvalue__ObjIndex)),
        obj(nullptr),
        index(nullptr),
        spids(NewList<int>()) {
  }

  lvalue__ObjIndex(void* obj, void* index)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::ObjIndex),
                      field_mask(), sizeof(lvalue__ObjIndex)),
        obj(obj),
        index(index),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  void* obj;
  void* index;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(lvalue__ObjIndex, obj))
         | maskbit(offsetof(lvalue__ObjIndex, index))
         | maskbit(offsetof(lvalue__ObjIndex, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(lvalue__ObjIndex)
};

class lvalue__ObjAttr : public lvalue_t {
 public:
  lvalue__ObjAttr()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::ObjAttr),
                      field_mask(), sizeof(lvalue__ObjAttr)),
        obj(nullptr),
        attr(StrFromC("")),
        spids(NewList<int>()) {
  }

  lvalue__ObjAttr(void* obj, Str* attr)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(lvalue_e::ObjAttr),
                      field_mask(), sizeof(lvalue__ObjAttr)),
        obj(obj),
        attr(attr),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  void* obj;
  Str* attr;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(lvalue__ObjAttr, obj))
         | maskbit(offsetof(lvalue__ObjAttr, attr))
         | maskbit(offsetof(lvalue__ObjAttr, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(lvalue__ObjAttr)
};

namespace lvalue {
  typedef lvalue__Named Named;
  typedef lvalue__Indexed Indexed;
  typedef lvalue__Keyed Keyed;
  typedef lvalue__ObjIndex ObjIndex;
  typedef lvalue__ObjAttr ObjAttr;
}

namespace redirect_arg_e {
  const int Path = 1;
  const int CopyFd = 2;
  const int MoveFd = 3;
  const int CloseFd = 4;
  const int HereDoc = 5;
};

const char* redirect_arg_str(int tag);

class redirect_arg_t {
 protected:
  redirect_arg_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(redirect_arg_t)
};

class redirect_arg__Path : public redirect_arg_t {
 public:
  redirect_arg__Path()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::Path),
                      field_mask(), sizeof(redirect_arg__Path)),
        filename(StrFromC("")) {
  }

  redirect_arg__Path(Str* filename)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::Path),
                      field_mask(), sizeof(redirect_arg__Path)),
        filename(filename) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* filename;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redirect_arg__Path, filename));
  }

  DISALLOW_COPY_AND_ASSIGN(redirect_arg__Path)
};

class redirect_arg__CopyFd : public redirect_arg_t {
 public:
  redirect_arg__CopyFd()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::CopyFd),
                      kZeroMask, sizeof(redirect_arg__CopyFd)),
        target_fd(-1) {
  }

  redirect_arg__CopyFd(int target_fd)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::CopyFd),
                      kZeroMask, sizeof(redirect_arg__CopyFd)),
        target_fd(target_fd) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int target_fd;

  DISALLOW_COPY_AND_ASSIGN(redirect_arg__CopyFd)
};

class redirect_arg__MoveFd : public redirect_arg_t {
 public:
  redirect_arg__MoveFd()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::MoveFd),
                      kZeroMask, sizeof(redirect_arg__MoveFd)),
        target_fd(-1) {
  }

  redirect_arg__MoveFd(int target_fd)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::MoveFd),
                      kZeroMask, sizeof(redirect_arg__MoveFd)),
        target_fd(target_fd) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int target_fd;

  DISALLOW_COPY_AND_ASSIGN(redirect_arg__MoveFd)
};

class redirect_arg__CloseFd : public redirect_arg_t {
 public:
  redirect_arg__CloseFd()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::CloseFd),
                      kZeroMask, sizeof(redirect_arg__CloseFd)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(redirect_arg__CloseFd)
};

class redirect_arg__HereDoc : public redirect_arg_t {
 public:
  redirect_arg__HereDoc()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::HereDoc),
                      field_mask(), sizeof(redirect_arg__HereDoc)),
        body(StrFromC("")) {
  }

  redirect_arg__HereDoc(Str* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redirect_arg_e::HereDoc),
                      field_mask(), sizeof(redirect_arg__HereDoc)),
        body(body) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* body;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redirect_arg__HereDoc, body));
  }

  DISALLOW_COPY_AND_ASSIGN(redirect_arg__HereDoc)
};

namespace redirect_arg {
  typedef redirect_arg__Path Path;
  typedef redirect_arg__CopyFd CopyFd;
  typedef redirect_arg__MoveFd MoveFd;
  typedef redirect_arg__CloseFd CloseFd;
  typedef redirect_arg__HereDoc HereDoc;
}

namespace wait_status_e {
  const int Proc = 1;
  const int Pipeline = 2;
  const int Cancelled = 3;
};

const char* wait_status_str(int tag);

class wait_status_t {
 protected:
  wait_status_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(wait_status_t)
};

class wait_status__Proc : public wait_status_t {
 public:
  wait_status__Proc()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Proc),
                      kZeroMask, sizeof(wait_status__Proc)),
        code(-1) {
  }

  wait_status__Proc(int code)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Proc),
                      kZeroMask, sizeof(wait_status__Proc)),
        code(code) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int code;

  DISALLOW_COPY_AND_ASSIGN(wait_status__Proc)
};

class wait_status__Pipeline : public wait_status_t {
 public:
  wait_status__Pipeline()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Pipeline),
                      field_mask(), sizeof(wait_status__Pipeline)),
        codes(NewList<int>()) {
  }

  wait_status__Pipeline(List<int>* codes)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Pipeline),
                      field_mask(), sizeof(wait_status__Pipeline)),
        codes(codes) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* codes;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(wait_status__Pipeline, codes));
  }

  DISALLOW_COPY_AND_ASSIGN(wait_status__Pipeline)
};

class wait_status__Cancelled : public wait_status_t {
 public:
  wait_status__Cancelled()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Cancelled),
                      kZeroMask, sizeof(wait_status__Cancelled)),
        sig_num(-1) {
  }

  wait_status__Cancelled(int sig_num)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(wait_status_e::Cancelled),
                      kZeroMask, sizeof(wait_status__Cancelled)),
        sig_num(sig_num) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int sig_num;

  DISALLOW_COPY_AND_ASSIGN(wait_status__Cancelled)
};

namespace wait_status {
  typedef wait_status__Proc Proc;
  typedef wait_status__Pipeline Pipeline;
  typedef wait_status__Cancelled Cancelled;
}

enum class span_e {
  Black = 1,
  Delim = 2,
  Backslash = 3,
};
typedef span_e span_t;

const char* span_str(span_e tag);

namespace emit_i {
  const int Part = 1;
  const int Delim = 2;
  const int Empty = 3;
  const int Escape = 4;
  const int Nothing = 5;
  const int ARRAY_SIZE = 6;
};

const char* emit_str(int tag);

typedef int emit_t;

namespace state_i {
  const int Invalid = 1;
  const int Start = 2;
  const int DE_White1 = 3;
  const int DE_Gray = 4;
  const int DE_White2 = 5;
  const int Black = 6;
  const int Backslash = 7;
  const int Done = 8;
  const int ARRAY_SIZE = 9;
};

const char* state_str(int tag);

typedef int state_t;

namespace char_kind_i {
  const int DE_White = 1;
  const int DE_Gray = 2;
  const int Black = 3;
  const int Backslash = 4;
  const int Sentinel = 5;
  const int ARRAY_SIZE = 6;
};

const char* char_kind_str(int tag);

typedef int char_kind_t;

enum class job_state_e {
  Running = 1,
  Done = 2,
  Stopped = 3,
};
typedef job_state_e job_state_t;

const char* job_state_str(job_state_e tag);

enum class flag_type_e {
  Bool = 1,
  Int = 2,
  Float = 3,
  Str = 4,
};
typedef flag_type_e flag_type_t;

const char* flag_type_str(flag_type_e tag);

namespace trace_e {
  const int External = 1;
  const int CommandSub = 2;
  const int ForkWait = 3;
  const int Fork = 4;
  const int PipelinePart = 5;
  const int ProcessSub = 6;
  const int HereDoc = 7;
};

const char* trace_str(int tag);

class trace_t {
 protected:
  trace_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(trace_t)
};

class trace__External : public trace_t {
 public:
  trace__External()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::External),
                      field_mask(), sizeof(trace__External)),
        argv(NewList<Str*>()) {
  }

  trace__External(List<Str*>* argv)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::External),
                      field_mask(), sizeof(trace__External)),
        argv(argv) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Str*>* argv;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(trace__External, argv));
  }

  DISALLOW_COPY_AND_ASSIGN(trace__External)
};

class trace__CommandSub : public trace_t {
 public:
  trace__CommandSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::CommandSub),
                      kZeroMask, sizeof(trace__CommandSub)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__CommandSub)
};

class trace__ForkWait : public trace_t {
 public:
  trace__ForkWait()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::ForkWait),
                      kZeroMask, sizeof(trace__ForkWait)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__ForkWait)
};

class trace__Fork : public trace_t {
 public:
  trace__Fork()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::Fork),
                      kZeroMask, sizeof(trace__Fork)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__Fork)
};

class trace__PipelinePart : public trace_t {
 public:
  trace__PipelinePart()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::PipelinePart),
                      kZeroMask, sizeof(trace__PipelinePart)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__PipelinePart)
};

class trace__ProcessSub : public trace_t {
 public:
  trace__ProcessSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::ProcessSub),
                      kZeroMask, sizeof(trace__ProcessSub)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__ProcessSub)
};

class trace__HereDoc : public trace_t {
 public:
  trace__HereDoc()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(trace_e::HereDoc),
                      kZeroMask, sizeof(trace__HereDoc)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(trace__HereDoc)
};

namespace trace {
  typedef trace__External External;
  typedef trace__CommandSub CommandSub;
  typedef trace__ForkWait ForkWait;
  typedef trace__Fork Fork;
  typedef trace__PipelinePart PipelinePart;
  typedef trace__ProcessSub ProcessSub;
  typedef trace__HereDoc HereDoc;
}

enum class word_style_e {
  Expr = 1,
  Unquoted = 2,
  DQ = 3,
  SQ = 4,
};
typedef word_style_e word_style_t;

const char* word_style_str(word_style_e tag);

class assign_arg {
 public:
  assign_arg()
      : GC_ASDL_CLASS(header_, 64,
                      field_mask(), sizeof(assign_arg)),
        var_name(StrFromC("")),
        rval(nullptr),
        plus_eq(false),
        spid(-1) {
  }

  assign_arg(Str* var_name, value_t* rval, bool plus_eq, int spid)
      : GC_ASDL_CLASS(header_, 64,
                      field_mask(), sizeof(assign_arg)),
        var_name(var_name),
        rval(rval),
        plus_eq(plus_eq),
        spid(spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* var_name;
  value_t* rval;
  bool plus_eq;
  int spid;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(assign_arg, var_name))
         | maskbit(offsetof(assign_arg, rval));
  }

  DISALLOW_COPY_AND_ASSIGN(assign_arg)
};

class VTestPlace {
 public:
  VTestPlace()
      : GC_ASDL_CLASS(header_, 65,
                      field_mask(), sizeof(VTestPlace)),
        name(StrFromC("")),
        index(nullptr) {
  }

  VTestPlace(Str* name, a_index_t* index)
      : GC_ASDL_CLASS(header_, 65,
                      field_mask(), sizeof(VTestPlace)),
        name(name),
        index(index) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  a_index_t* index;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(VTestPlace, name))
         | maskbit(offsetof(VTestPlace, index));
  }

  DISALLOW_COPY_AND_ASSIGN(VTestPlace)
};

class VarSubState {
 public:
  VarSubState()
      : GC_ASDL_CLASS(header_, 66,
                      kZeroMask, sizeof(VarSubState)),
        join_array(false),
        is_type_query(false) {
  }

  VarSubState(bool join_array, bool is_type_query)
      : GC_ASDL_CLASS(header_, 66,
                      kZeroMask, sizeof(VarSubState)),
        join_array(join_array),
        is_type_query(is_type_query) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool join_array;
  bool is_type_query;

  DISALLOW_COPY_AND_ASSIGN(VarSubState)
};

class cell {
 public:
  cell()
      : GC_ASDL_CLASS(header_, 67,
                      field_mask(), sizeof(cell)),
        exported(false),
        readonly(false),
        nameref(false),
        val(nullptr) {
  }

  cell(bool exported, bool readonly, bool nameref, value_t* val)
      : GC_ASDL_CLASS(header_, 67,
                      field_mask(), sizeof(cell)),
        exported(exported),
        readonly(readonly),
        nameref(nameref),
        val(val) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool exported;
  bool readonly;
  bool nameref;
  value_t* val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(cell, val));
  }

  DISALLOW_COPY_AND_ASSIGN(cell)
};

class redirect {
 public:
  redirect()
      : GC_ASDL_CLASS(header_, 68,
                      field_mask(), sizeof(redirect)),
        op_id(-1),
        op_spid(-1),
        loc(nullptr),
        arg(nullptr) {
  }

  redirect(Id_t op_id, int op_spid, syntax_asdl::redir_loc_t* loc,
           redirect_arg_t* arg)
      : GC_ASDL_CLASS(header_, 68,
                      field_mask(), sizeof(redirect)),
        op_id(op_id),
        op_spid(op_spid),
        loc(loc),
        arg(arg) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  int op_spid;
  syntax_asdl::redir_loc_t* loc;
  redirect_arg_t* arg;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redirect, loc))
         | maskbit(offsetof(redirect, arg));
  }

  DISALLOW_COPY_AND_ASSIGN(redirect)
};

class Proc {
 public:
  Proc()
      : GC_ASDL_CLASS(header_, 69,
                      field_mask(), sizeof(Proc)),
        name(StrFromC("")),
        name_spid(-1),
        sig(nullptr),
        body(nullptr),
        defaults(NewList<value_t*>()),
        dynamic_scope(false) {
  }

  Proc(Str* name, int name_spid, syntax_asdl::proc_sig_t* sig,
       syntax_asdl::command_t* body, List<value_t*>* defaults, bool
       dynamic_scope)
      : GC_ASDL_CLASS(header_, 69,
                      field_mask(), sizeof(Proc)),
        name(name),
        name_spid(name_spid),
        sig(sig),
        body(body),
        defaults(defaults),
        dynamic_scope(dynamic_scope) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  int name_spid;
  syntax_asdl::proc_sig_t* sig;
  syntax_asdl::command_t* body;
  List<value_t*>* defaults;
  bool dynamic_scope;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(Proc, name))
         | maskbit(offsetof(Proc, sig))
         | maskbit(offsetof(Proc, body))
         | maskbit(offsetof(Proc, defaults));
  }

  DISALLOW_COPY_AND_ASSIGN(Proc)
};

class StatusArray {
 public:
  StatusArray()
      : GC_ASDL_CLASS(header_, 70,
                      field_mask(), sizeof(StatusArray)),
        codes(NewList<int>()),
        spids(NewList<int>()) {
  }

  StatusArray(List<int>* codes, List<int>* spids)
      : GC_ASDL_CLASS(header_, 70,
                      field_mask(), sizeof(StatusArray)),
        codes(codes),
        spids(spids) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* codes;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(StatusArray, codes))
         | maskbit(offsetof(StatusArray, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(StatusArray)
};

class CommandStatus {
 public:
  CommandStatus()
      : GC_ASDL_CLASS(header_, 71,
                      field_mask(), sizeof(CommandStatus)),
        check_errexit(false),
        pipe_negated(false),
        pipe_status(NewList<int>()),
        pipe_spids(NewList<int>()),
        show_code(false) {
  }

  CommandStatus(bool check_errexit, bool pipe_negated, List<int>* pipe_status,
                List<int>* pipe_spids, bool show_code)
      : GC_ASDL_CLASS(header_, 71,
                      field_mask(), sizeof(CommandStatus)),
        check_errexit(check_errexit),
        pipe_negated(pipe_negated),
        pipe_status(pipe_status),
        pipe_spids(pipe_spids),
        show_code(show_code) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool check_errexit;
  bool pipe_negated;
  List<int>* pipe_status;
  List<int>* pipe_spids;
  bool show_code;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(CommandStatus, pipe_status))
         | maskbit(offsetof(CommandStatus, pipe_spids));
  }

  DISALLOW_COPY_AND_ASSIGN(CommandStatus)
};

class hay_node {
 public:
  hay_node()
      : GC_ASDL_CLASS(header_, 72,
                      field_mask(), sizeof(hay_node)),
        children(NewDict<Str*, hay_node*>()) {
  }

  hay_node(Dict<Str*, hay_node*>* children)
      : GC_ASDL_CLASS(header_, 72,
                      field_mask(), sizeof(hay_node)),
        children(children) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Dict<Str*, hay_node*>* children;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(hay_node, children));
  }

  DISALLOW_COPY_AND_ASSIGN(hay_node)
};


}  // namespace runtime_asdl

#endif  // RUNTIME_ASDL
