// _gen/frontend/syntax.asdl.h is generated by asdl_main.py

#ifndef SYNTAX_ASDL
#define SYNTAX_ASDL

#include <cstdint>

#include "mycpp/runtime.h"
#include "_gen/asdl/hnode.asdl.h"
using hnode_asdl::hnode_t;

#include "_gen/frontend/id_kind.asdl.h"
using id_kind_asdl::Id_t;

namespace syntax_asdl {

class parse_result_t;
class source_t;
class line_span;
class Token;
class speck;
class bracket_op_t;
class suffix_op_t;
class double_quoted;
class single_quoted;
class simple_var_sub;
class braced_var_sub;
class command_sub;
class sh_array_literal;
class ArgList;
class word_part_t;
class compound_word;
class string_line;
class triple_quoted;
class word_t;
class sh_lhs_expr_t;
class arith_expr_t;
class bool_expr_t;
class redir_loc_t;
class redir_param_t;
class redir;
class assign_pair;
class env_pair;
class condition_t;
class case_arm;
class if_arm;
class for_iter_t;
class BraceGroup;
class command_t;
class variant_type_t;
class variant;
class class_item_t;
class import_name;
class UntypedParam;
class TypedParam;
class proc_sig_t;
class param;
class glob_part_t;
class printf_part_t;
class type_expr_t;
class name_type;
class comprehension;
class named_arg;
class subscript;
class attribute;
class place_expr_t;
class expr_t;
class posix_class;
class perl_class;
class class_literal_term_t;
class CharCode;
class char_class_term_t;
class re_repeat_t;
class re_t;

namespace parse_result_e {
  const int EmptyLine = 1;
  const int Eof = 2;
  const int Node = 3;
};

const char* parse_result_str(int tag);

class parse_result_t {
 protected:
  parse_result_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(parse_result_t)
};

class parse_result__EmptyLine : public parse_result_t {
 public:
  parse_result__EmptyLine()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(parse_result_e::EmptyLine),
                      kZeroMask, sizeof(parse_result__EmptyLine)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(parse_result__EmptyLine)
};

class parse_result__Eof : public parse_result_t {
 public:
  parse_result__Eof()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(parse_result_e::Eof),
                      kZeroMask, sizeof(parse_result__Eof)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(parse_result__Eof)
};

class parse_result__Node : public parse_result_t {
 public:
  parse_result__Node()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(parse_result_e::Node),
                      field_mask(), sizeof(parse_result__Node)),
        cmd(nullptr) {
  }

  parse_result__Node(command_t* cmd)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(parse_result_e::Node),
                      field_mask(), sizeof(parse_result__Node)),
        cmd(cmd) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  command_t* cmd;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(parse_result__Node, cmd));
  }

  DISALLOW_COPY_AND_ASSIGN(parse_result__Node)
};

namespace parse_result {
  typedef parse_result__EmptyLine EmptyLine;
  typedef parse_result__Eof Eof;
  typedef parse_result__Node Node;
}

namespace source_e {
  const int Interactive = 1;
  const int Headless = 2;
  const int Unused = 3;
  const int CFlag = 4;
  const int Stdin = 5;
  const int MainFile = 6;
  const int SourcedFile = 7;
  const int ArgvWord = 8;
  const int Variable = 9;
  const int Alias = 10;
  const int Reparsed = 11;
  const int Synthetic = 12;
};

const char* source_str(int tag);

class source_t {
 protected:
  source_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(source_t)
};

class source__Interactive : public source_t {
 public:
  source__Interactive()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Interactive),
                      kZeroMask, sizeof(source__Interactive)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(source__Interactive)
};

class source__Headless : public source_t {
 public:
  source__Headless()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Headless),
                      kZeroMask, sizeof(source__Headless)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(source__Headless)
};

class source__Unused : public source_t {
 public:
  source__Unused()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Unused),
                      field_mask(), sizeof(source__Unused)),
        comment(StrFromC("")) {
  }

  source__Unused(Str* comment)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Unused),
                      field_mask(), sizeof(source__Unused)),
        comment(comment) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* comment;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Unused, comment));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Unused)
};

class source__CFlag : public source_t {
 public:
  source__CFlag()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::CFlag),
                      kZeroMask, sizeof(source__CFlag)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(source__CFlag)
};

class source__Stdin : public source_t {
 public:
  source__Stdin()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Stdin),
                      field_mask(), sizeof(source__Stdin)),
        comment(StrFromC("")) {
  }

  source__Stdin(Str* comment)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Stdin),
                      field_mask(), sizeof(source__Stdin)),
        comment(comment) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* comment;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Stdin, comment));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Stdin)
};

class source__MainFile : public source_t {
 public:
  source__MainFile()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::MainFile),
                      field_mask(), sizeof(source__MainFile)),
        path(StrFromC("")) {
  }

  source__MainFile(Str* path)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::MainFile),
                      field_mask(), sizeof(source__MainFile)),
        path(path) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* path;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__MainFile, path));
  }

  DISALLOW_COPY_AND_ASSIGN(source__MainFile)
};

class source__SourcedFile : public source_t {
 public:
  source__SourcedFile()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::SourcedFile),
                      field_mask(), sizeof(source__SourcedFile)),
        path(StrFromC("")),
        spid(-1) {
  }

  source__SourcedFile(Str* path, int spid)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::SourcedFile),
                      field_mask(), sizeof(source__SourcedFile)),
        path(path),
        spid(spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* path;
  int spid;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__SourcedFile, path));
  }

  DISALLOW_COPY_AND_ASSIGN(source__SourcedFile)
};

class source__ArgvWord : public source_t {
 public:
  source__ArgvWord()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::ArgvWord),
                      field_mask(), sizeof(source__ArgvWord)),
        what(StrFromC("")),
        span_id(-1) {
  }

  source__ArgvWord(Str* what, int span_id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::ArgvWord),
                      field_mask(), sizeof(source__ArgvWord)),
        what(what),
        span_id(span_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* what;
  int span_id;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__ArgvWord, what));
  }

  DISALLOW_COPY_AND_ASSIGN(source__ArgvWord)
};

class source__Variable : public source_t {
 public:
  source__Variable()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Variable),
                      field_mask(), sizeof(source__Variable)),
        var_name(StrFromC("")),
        span_id(-1) {
  }

  source__Variable(Str* var_name, int span_id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Variable),
                      field_mask(), sizeof(source__Variable)),
        var_name(var_name),
        span_id(span_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* var_name;
  int span_id;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Variable, var_name));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Variable)
};

class source__Alias : public source_t {
 public:
  source__Alias()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Alias),
                      field_mask(), sizeof(source__Alias)),
        argv0(StrFromC("")),
        argv0_spid(-1) {
  }

  source__Alias(Str* argv0, int argv0_spid)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Alias),
                      field_mask(), sizeof(source__Alias)),
        argv0(argv0),
        argv0_spid(argv0_spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* argv0;
  int argv0_spid;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Alias, argv0));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Alias)
};

class source__Reparsed : public source_t {
 public:
  source__Reparsed()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Reparsed),
                      field_mask(), sizeof(source__Reparsed)),
        what(StrFromC("")),
        left_spid(-1),
        right_spid(-1) {
  }

  source__Reparsed(Str* what, int left_spid, int right_spid)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Reparsed),
                      field_mask(), sizeof(source__Reparsed)),
        what(what),
        left_spid(left_spid),
        right_spid(right_spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* what;
  int left_spid;
  int right_spid;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Reparsed, what));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Reparsed)
};

class source__Synthetic : public source_t {
 public:
  source__Synthetic()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Synthetic),
                      field_mask(), sizeof(source__Synthetic)),
        s(StrFromC("")) {
  }

  source__Synthetic(Str* s)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(source_e::Synthetic),
                      field_mask(), sizeof(source__Synthetic)),
        s(s) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* s;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(source__Synthetic, s));
  }

  DISALLOW_COPY_AND_ASSIGN(source__Synthetic)
};

namespace source {
  typedef source__Interactive Interactive;
  typedef source__Headless Headless;
  typedef source__Unused Unused;
  typedef source__CFlag CFlag;
  typedef source__Stdin Stdin;
  typedef source__MainFile MainFile;
  typedef source__SourcedFile SourcedFile;
  typedef source__ArgvWord ArgvWord;
  typedef source__Variable Variable;
  typedef source__Alias Alias;
  typedef source__Reparsed Reparsed;
  typedef source__Synthetic Synthetic;
}

namespace bracket_op_e {
  const int WholeArray = 1;
  const int ArrayIndex = 2;
};

const char* bracket_op_str(int tag);

class bracket_op_t {
 protected:
  bracket_op_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(bracket_op_t)
};

class bracket_op__WholeArray : public bracket_op_t {
 public:
  bracket_op__WholeArray()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bracket_op_e::WholeArray),
                      kZeroMask, sizeof(bracket_op__WholeArray)),
        op_id(-1) {
  }

  bracket_op__WholeArray(Id_t op_id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bracket_op_e::WholeArray),
                      kZeroMask, sizeof(bracket_op__WholeArray)),
        op_id(op_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;

  DISALLOW_COPY_AND_ASSIGN(bracket_op__WholeArray)
};

class bracket_op__ArrayIndex : public bracket_op_t {
 public:
  bracket_op__ArrayIndex()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bracket_op_e::ArrayIndex),
                      field_mask(), sizeof(bracket_op__ArrayIndex)),
        expr(nullptr) {
  }

  bracket_op__ArrayIndex(arith_expr_t* expr)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bracket_op_e::ArrayIndex),
                      field_mask(), sizeof(bracket_op__ArrayIndex)),
        expr(expr) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* expr;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bracket_op__ArrayIndex, expr));
  }

  DISALLOW_COPY_AND_ASSIGN(bracket_op__ArrayIndex)
};

namespace bracket_op {
  typedef bracket_op__WholeArray WholeArray;
  typedef bracket_op__ArrayIndex ArrayIndex;
}

namespace suffix_op_e {
  const int Nullary = 65;
  const int Unary = 2;
  const int Static = 3;
  const int PatSub = 4;
  const int Slice = 5;
};

const char* suffix_op_str(int tag);

class suffix_op_t {
 protected:
  suffix_op_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(suffix_op_t)
};

class suffix_op__Unary : public suffix_op_t {
 public:
  suffix_op__Unary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Unary),
                      field_mask(), sizeof(suffix_op__Unary)),
        tok(nullptr),
        arg_word(nullptr),
        spids(NewList<int>()) {
  }

  suffix_op__Unary(Token* tok, word_t* arg_word)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Unary),
                      field_mask(), sizeof(suffix_op__Unary)),
        tok(tok),
        arg_word(arg_word),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* tok;
  word_t* arg_word;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(suffix_op__Unary, tok))
         | maskbit(offsetof(suffix_op__Unary, arg_word))
         | maskbit(offsetof(suffix_op__Unary, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(suffix_op__Unary)
};

class suffix_op__Static : public suffix_op_t {
 public:
  suffix_op__Static()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Static),
                      field_mask(), sizeof(suffix_op__Static)),
        tok(nullptr),
        arg(StrFromC("")),
        spids(NewList<int>()) {
  }

  suffix_op__Static(Token* tok, Str* arg)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Static),
                      field_mask(), sizeof(suffix_op__Static)),
        tok(tok),
        arg(arg),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* tok;
  Str* arg;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(suffix_op__Static, tok))
         | maskbit(offsetof(suffix_op__Static, arg))
         | maskbit(offsetof(suffix_op__Static, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(suffix_op__Static)
};

class suffix_op__PatSub : public suffix_op_t {
 public:
  suffix_op__PatSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::PatSub),
                      field_mask(), sizeof(suffix_op__PatSub)),
        pat(nullptr),
        replace(nullptr),
        replace_mode(-1),
        spids(NewList<int>()) {
  }

  suffix_op__PatSub(word_t* pat, word_t* replace, Id_t replace_mode)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::PatSub),
                      field_mask(), sizeof(suffix_op__PatSub)),
        pat(pat),
        replace(replace),
        replace_mode(replace_mode),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  word_t* pat;
  word_t* replace;
  Id_t replace_mode;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(suffix_op__PatSub, pat))
         | maskbit(offsetof(suffix_op__PatSub, replace))
         | maskbit(offsetof(suffix_op__PatSub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(suffix_op__PatSub)
};

class suffix_op__Slice : public suffix_op_t {
 public:
  suffix_op__Slice()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Slice),
                      field_mask(), sizeof(suffix_op__Slice)),
        begin(nullptr),
        length(nullptr),
        spids(NewList<int>()) {
  }

  suffix_op__Slice(arith_expr_t* begin, arith_expr_t* length)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(suffix_op_e::Slice),
                      field_mask(), sizeof(suffix_op__Slice)),
        begin(begin),
        length(length),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* begin;
  arith_expr_t* length;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(suffix_op__Slice, begin))
         | maskbit(offsetof(suffix_op__Slice, length))
         | maskbit(offsetof(suffix_op__Slice, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(suffix_op__Slice)
};

namespace suffix_op {
  typedef suffix_op__Unary Unary;
  typedef suffix_op__Static Static;
  typedef suffix_op__PatSub PatSub;
  typedef suffix_op__Slice Slice;
}

namespace word_part_e {
  const int ShArrayLiteral = 72;
  const int AssocArrayLiteral = 2;
  const int Literal = 65;
  const int EscapedLiteral = 4;
  const int SingleQuoted = 68;
  const int DoubleQuoted = 67;
  const int SimpleVarSub = 69;
  const int BracedVarSub = 70;
  const int CommandSub = 71;
  const int TildeSub = 10;
  const int ArithSub = 11;
  const int BracedTuple = 12;
  const int BracedRange = 13;
  const int ExtGlob = 14;
  const int Splice = 15;
  const int FuncCall = 16;
  const int ExprSub = 17;
};

const char* word_part_str(int tag);

class word_part_t {
 protected:
  word_part_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(word_part_t)
};

class word_part__AssocArrayLiteral : public word_part_t {
 public:
  word_part__AssocArrayLiteral()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::AssocArrayLiteral),
                      field_mask(), sizeof(word_part__AssocArrayLiteral)),
        left(nullptr),
        pairs(NewList<compound_word*>()),
        spids(NewList<int>()) {
  }

  word_part__AssocArrayLiteral(Token* left, List<compound_word*>* pairs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::AssocArrayLiteral),
                      field_mask(), sizeof(word_part__AssocArrayLiteral)),
        left(left),
        pairs(pairs),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  List<compound_word*>* pairs;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__AssocArrayLiteral, left))
         | maskbit(offsetof(word_part__AssocArrayLiteral, pairs))
         | maskbit(offsetof(word_part__AssocArrayLiteral, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__AssocArrayLiteral)
};

class word_part__EscapedLiteral : public word_part_t {
 public:
  word_part__EscapedLiteral()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::EscapedLiteral),
                      field_mask(), sizeof(word_part__EscapedLiteral)),
        token(nullptr),
        spids(NewList<int>()) {
  }

  word_part__EscapedLiteral(Token* token)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::EscapedLiteral),
                      field_mask(), sizeof(word_part__EscapedLiteral)),
        token(token),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__EscapedLiteral, token))
         | maskbit(offsetof(word_part__EscapedLiteral, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__EscapedLiteral)
};

class word_part__TildeSub : public word_part_t {
 public:
  word_part__TildeSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::TildeSub),
                      field_mask(), sizeof(word_part__TildeSub)),
        token(nullptr),
        spids(NewList<int>()) {
  }

  word_part__TildeSub(Token* token)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::TildeSub),
                      field_mask(), sizeof(word_part__TildeSub)),
        token(token),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__TildeSub, token))
         | maskbit(offsetof(word_part__TildeSub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__TildeSub)
};

class word_part__ArithSub : public word_part_t {
 public:
  word_part__ArithSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ArithSub),
                      field_mask(), sizeof(word_part__ArithSub)),
        anode(nullptr),
        spids(NewList<int>()) {
  }

  word_part__ArithSub(arith_expr_t* anode)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ArithSub),
                      field_mask(), sizeof(word_part__ArithSub)),
        anode(anode),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* anode;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__ArithSub, anode))
         | maskbit(offsetof(word_part__ArithSub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__ArithSub)
};

class word_part__BracedTuple : public word_part_t {
 public:
  word_part__BracedTuple()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::BracedTuple),
                      field_mask(), sizeof(word_part__BracedTuple)),
        words(NewList<compound_word*>()),
        spids(NewList<int>()) {
  }

  word_part__BracedTuple(List<compound_word*>* words)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::BracedTuple),
                      field_mask(), sizeof(word_part__BracedTuple)),
        words(words),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<compound_word*>* words;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__BracedTuple, words))
         | maskbit(offsetof(word_part__BracedTuple, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__BracedTuple)
};

class word_part__BracedRange : public word_part_t {
 public:
  word_part__BracedRange()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::BracedRange),
                      field_mask(), sizeof(word_part__BracedRange)),
        kind(-1),
        start(StrFromC("")),
        end(StrFromC("")),
        step(-1),
        spids(NewList<int>()) {
  }

  word_part__BracedRange(Id_t kind, Str* start, Str* end, int step)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::BracedRange),
                      field_mask(), sizeof(word_part__BracedRange)),
        kind(kind),
        start(start),
        end(end),
        step(step),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t kind;
  Str* start;
  Str* end;
  int step;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__BracedRange, start))
         | maskbit(offsetof(word_part__BracedRange, end))
         | maskbit(offsetof(word_part__BracedRange, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__BracedRange)
};

class word_part__ExtGlob : public word_part_t {
 public:
  word_part__ExtGlob()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ExtGlob),
                      field_mask(), sizeof(word_part__ExtGlob)),
        op(nullptr),
        arms(NewList<compound_word*>()),
        spids(NewList<int>()) {
  }

  word_part__ExtGlob(Token* op, List<compound_word*>* arms)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ExtGlob),
                      field_mask(), sizeof(word_part__ExtGlob)),
        op(op),
        arms(arms),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* op;
  List<compound_word*>* arms;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__ExtGlob, op))
         | maskbit(offsetof(word_part__ExtGlob, arms))
         | maskbit(offsetof(word_part__ExtGlob, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__ExtGlob)
};

class word_part__Splice : public word_part_t {
 public:
  word_part__Splice()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::Splice),
                      field_mask(), sizeof(word_part__Splice)),
        name(nullptr),
        spids(NewList<int>()) {
  }

  word_part__Splice(Token* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::Splice),
                      field_mask(), sizeof(word_part__Splice)),
        name(name),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__Splice, name))
         | maskbit(offsetof(word_part__Splice, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__Splice)
};

class word_part__FuncCall : public word_part_t {
 public:
  word_part__FuncCall()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::FuncCall),
                      field_mask(), sizeof(word_part__FuncCall)),
        name(nullptr),
        args(nullptr),
        spids(NewList<int>()) {
  }

  word_part__FuncCall(Token* name, ArgList* args)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::FuncCall),
                      field_mask(), sizeof(word_part__FuncCall)),
        name(name),
        args(args),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  ArgList* args;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__FuncCall, name))
         | maskbit(offsetof(word_part__FuncCall, args))
         | maskbit(offsetof(word_part__FuncCall, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__FuncCall)
};

class word_part__ExprSub : public word_part_t {
 public:
  word_part__ExprSub()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ExprSub),
                      field_mask(), sizeof(word_part__ExprSub)),
        left(nullptr),
        child(nullptr),
        spids(NewList<int>()) {
  }

  word_part__ExprSub(Token* left, expr_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_part_e::ExprSub),
                      field_mask(), sizeof(word_part__ExprSub)),
        left(left),
        child(child),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  expr_t* child;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word_part__ExprSub, left))
         | maskbit(offsetof(word_part__ExprSub, child))
         | maskbit(offsetof(word_part__ExprSub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(word_part__ExprSub)
};

namespace word_part {
  typedef word_part__AssocArrayLiteral AssocArrayLiteral;
  typedef word_part__EscapedLiteral EscapedLiteral;
  typedef word_part__TildeSub TildeSub;
  typedef word_part__ArithSub ArithSub;
  typedef word_part__BracedTuple BracedTuple;
  typedef word_part__BracedRange BracedRange;
  typedef word_part__ExtGlob ExtGlob;
  typedef word_part__Splice Splice;
  typedef word_part__FuncCall FuncCall;
  typedef word_part__ExprSub ExprSub;
}

namespace word_e {
  const int Empty = 1;
  const int Token = 65;
  const int Compound = 74;
  const int BracedTree = 4;
  const int String = 5;
};

const char* word_str(int tag);

class word_t {
 protected:
  word_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(word_t)
};

class word__Empty : public word_t {
 public:
  word__Empty()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_e::Empty),
                      kZeroMask, sizeof(word__Empty)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(word__Empty)
};

class word__BracedTree : public word_t {
 public:
  word__BracedTree()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_e::BracedTree),
                      field_mask(), sizeof(word__BracedTree)),
        parts(NewList<word_part_t*>()) {
  }

  word__BracedTree(List<word_part_t*>* parts)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_e::BracedTree),
                      field_mask(), sizeof(word__BracedTree)),
        parts(parts) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<word_part_t*>* parts;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word__BracedTree, parts));
  }

  DISALLOW_COPY_AND_ASSIGN(word__BracedTree)
};

class word__String : public word_t {
 public:
  word__String()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_e::String),
                      field_mask(), sizeof(word__String)),
        id(-1),
        s(StrFromC("")),
        span_id(-1) {
  }

  word__String(Id_t id, Str* s, int span_id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(word_e::String),
                      field_mask(), sizeof(word__String)),
        id(id),
        s(s),
        span_id(span_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t id;
  Str* s;
  int span_id;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(word__String, s));
  }

  DISALLOW_COPY_AND_ASSIGN(word__String)
};

namespace word {
  typedef word__Empty Empty;
  typedef word__BracedTree BracedTree;
  typedef word__String String;
}

namespace sh_lhs_expr_e {
  const int Name = 1;
  const int IndexedName = 2;
  const int UnparsedIndex = 3;
};

const char* sh_lhs_expr_str(int tag);

class sh_lhs_expr_t {
 protected:
  sh_lhs_expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(sh_lhs_expr_t)
};

class sh_lhs_expr__Name : public sh_lhs_expr_t {
 public:
  sh_lhs_expr__Name()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::Name),
                      field_mask(), sizeof(sh_lhs_expr__Name)),
        name(StrFromC("")),
        spids(NewList<int>()) {
  }

  sh_lhs_expr__Name(Str* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::Name),
                      field_mask(), sizeof(sh_lhs_expr__Name)),
        name(name),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(sh_lhs_expr__Name, name))
         | maskbit(offsetof(sh_lhs_expr__Name, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(sh_lhs_expr__Name)
};

class sh_lhs_expr__IndexedName : public sh_lhs_expr_t {
 public:
  sh_lhs_expr__IndexedName()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::IndexedName),
                      field_mask(), sizeof(sh_lhs_expr__IndexedName)),
        name(StrFromC("")),
        index(nullptr),
        spids(NewList<int>()) {
  }

  sh_lhs_expr__IndexedName(Str* name, arith_expr_t* index)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::IndexedName),
                      field_mask(), sizeof(sh_lhs_expr__IndexedName)),
        name(name),
        index(index),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  arith_expr_t* index;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(sh_lhs_expr__IndexedName, name))
         | maskbit(offsetof(sh_lhs_expr__IndexedName, index))
         | maskbit(offsetof(sh_lhs_expr__IndexedName, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(sh_lhs_expr__IndexedName)
};

class sh_lhs_expr__UnparsedIndex : public sh_lhs_expr_t {
 public:
  sh_lhs_expr__UnparsedIndex()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::UnparsedIndex),
                      field_mask(), sizeof(sh_lhs_expr__UnparsedIndex)),
        name(StrFromC("")),
        index(StrFromC("")),
        spids(NewList<int>()) {
  }

  sh_lhs_expr__UnparsedIndex(Str* name, Str* index)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(sh_lhs_expr_e::UnparsedIndex),
                      field_mask(), sizeof(sh_lhs_expr__UnparsedIndex)),
        name(name),
        index(index),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  Str* index;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(sh_lhs_expr__UnparsedIndex, name))
         | maskbit(offsetof(sh_lhs_expr__UnparsedIndex, index))
         | maskbit(offsetof(sh_lhs_expr__UnparsedIndex, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(sh_lhs_expr__UnparsedIndex)
};

namespace sh_lhs_expr {
  typedef sh_lhs_expr__Name Name;
  typedef sh_lhs_expr__IndexedName IndexedName;
  typedef sh_lhs_expr__UnparsedIndex UnparsedIndex;
}

namespace arith_expr_e {
  const int VarRef = 65;
  const int Word = 74;
  const int UnaryAssign = 3;
  const int BinaryAssign = 4;
  const int Unary = 5;
  const int Binary = 6;
  const int TernaryOp = 7;
};

const char* arith_expr_str(int tag);

class arith_expr_t {
 protected:
  arith_expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(arith_expr_t)
};

class arith_expr__UnaryAssign : public arith_expr_t {
 public:
  arith_expr__UnaryAssign()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::UnaryAssign),
                      field_mask(), sizeof(arith_expr__UnaryAssign)),
        op_id(-1),
        child(nullptr) {
  }

  arith_expr__UnaryAssign(Id_t op_id, arith_expr_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::UnaryAssign),
                      field_mask(), sizeof(arith_expr__UnaryAssign)),
        op_id(op_id),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  arith_expr_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(arith_expr__UnaryAssign, child));
  }

  DISALLOW_COPY_AND_ASSIGN(arith_expr__UnaryAssign)
};

class arith_expr__BinaryAssign : public arith_expr_t {
 public:
  arith_expr__BinaryAssign()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::BinaryAssign),
                      field_mask(), sizeof(arith_expr__BinaryAssign)),
        op_id(-1),
        left(nullptr),
        right(nullptr) {
  }

  arith_expr__BinaryAssign(Id_t op_id, arith_expr_t* left, arith_expr_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::BinaryAssign),
                      field_mask(), sizeof(arith_expr__BinaryAssign)),
        op_id(op_id),
        left(left),
        right(right) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  arith_expr_t* left;
  arith_expr_t* right;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(arith_expr__BinaryAssign, left))
         | maskbit(offsetof(arith_expr__BinaryAssign, right));
  }

  DISALLOW_COPY_AND_ASSIGN(arith_expr__BinaryAssign)
};

class arith_expr__Unary : public arith_expr_t {
 public:
  arith_expr__Unary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::Unary),
                      field_mask(), sizeof(arith_expr__Unary)),
        op_id(-1),
        child(nullptr) {
  }

  arith_expr__Unary(Id_t op_id, arith_expr_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::Unary),
                      field_mask(), sizeof(arith_expr__Unary)),
        op_id(op_id),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  arith_expr_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(arith_expr__Unary, child));
  }

  DISALLOW_COPY_AND_ASSIGN(arith_expr__Unary)
};

class arith_expr__Binary : public arith_expr_t {
 public:
  arith_expr__Binary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::Binary),
                      field_mask(), sizeof(arith_expr__Binary)),
        op_id(-1),
        left(nullptr),
        right(nullptr) {
  }

  arith_expr__Binary(Id_t op_id, arith_expr_t* left, arith_expr_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::Binary),
                      field_mask(), sizeof(arith_expr__Binary)),
        op_id(op_id),
        left(left),
        right(right) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  arith_expr_t* left;
  arith_expr_t* right;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(arith_expr__Binary, left))
         | maskbit(offsetof(arith_expr__Binary, right));
  }

  DISALLOW_COPY_AND_ASSIGN(arith_expr__Binary)
};

class arith_expr__TernaryOp : public arith_expr_t {
 public:
  arith_expr__TernaryOp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::TernaryOp),
                      field_mask(), sizeof(arith_expr__TernaryOp)),
        cond(nullptr),
        true_expr(nullptr),
        false_expr(nullptr) {
  }

  arith_expr__TernaryOp(arith_expr_t* cond, arith_expr_t* true_expr,
                        arith_expr_t* false_expr)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(arith_expr_e::TernaryOp),
                      field_mask(), sizeof(arith_expr__TernaryOp)),
        cond(cond),
        true_expr(true_expr),
        false_expr(false_expr) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* cond;
  arith_expr_t* true_expr;
  arith_expr_t* false_expr;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(arith_expr__TernaryOp, cond))
         | maskbit(offsetof(arith_expr__TernaryOp, true_expr))
         | maskbit(offsetof(arith_expr__TernaryOp, false_expr));
  }

  DISALLOW_COPY_AND_ASSIGN(arith_expr__TernaryOp)
};

namespace arith_expr {
  typedef arith_expr__UnaryAssign UnaryAssign;
  typedef arith_expr__BinaryAssign BinaryAssign;
  typedef arith_expr__Unary Unary;
  typedef arith_expr__Binary Binary;
  typedef arith_expr__TernaryOp TernaryOp;
}

namespace bool_expr_e {
  const int WordTest = 1;
  const int Binary = 2;
  const int Unary = 3;
  const int LogicalNot = 4;
  const int LogicalAnd = 5;
  const int LogicalOr = 6;
};

const char* bool_expr_str(int tag);

class bool_expr_t {
 protected:
  bool_expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(bool_expr_t)
};

class bool_expr__WordTest : public bool_expr_t {
 public:
  bool_expr__WordTest()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::WordTest),
                      field_mask(), sizeof(bool_expr__WordTest)),
        w(nullptr) {
  }

  bool_expr__WordTest(word_t* w)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::WordTest),
                      field_mask(), sizeof(bool_expr__WordTest)),
        w(w) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  word_t* w;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__WordTest, w));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__WordTest)
};

class bool_expr__Binary : public bool_expr_t {
 public:
  bool_expr__Binary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::Binary),
                      field_mask(), sizeof(bool_expr__Binary)),
        op_id(-1),
        left(nullptr),
        right(nullptr) {
  }

  bool_expr__Binary(Id_t op_id, word_t* left, word_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::Binary),
                      field_mask(), sizeof(bool_expr__Binary)),
        op_id(op_id),
        left(left),
        right(right) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  word_t* left;
  word_t* right;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__Binary, left))
         | maskbit(offsetof(bool_expr__Binary, right));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__Binary)
};

class bool_expr__Unary : public bool_expr_t {
 public:
  bool_expr__Unary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::Unary),
                      field_mask(), sizeof(bool_expr__Unary)),
        op_id(-1),
        child(nullptr) {
  }

  bool_expr__Unary(Id_t op_id, word_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::Unary),
                      field_mask(), sizeof(bool_expr__Unary)),
        op_id(op_id),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;
  word_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__Unary, child));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__Unary)
};

class bool_expr__LogicalNot : public bool_expr_t {
 public:
  bool_expr__LogicalNot()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalNot),
                      field_mask(), sizeof(bool_expr__LogicalNot)),
        child(nullptr) {
  }

  bool_expr__LogicalNot(bool_expr_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalNot),
                      field_mask(), sizeof(bool_expr__LogicalNot)),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool_expr_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__LogicalNot, child));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__LogicalNot)
};

class bool_expr__LogicalAnd : public bool_expr_t {
 public:
  bool_expr__LogicalAnd()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalAnd),
                      field_mask(), sizeof(bool_expr__LogicalAnd)),
        left(nullptr),
        right(nullptr) {
  }

  bool_expr__LogicalAnd(bool_expr_t* left, bool_expr_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalAnd),
                      field_mask(), sizeof(bool_expr__LogicalAnd)),
        left(left),
        right(right) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool_expr_t* left;
  bool_expr_t* right;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__LogicalAnd, left))
         | maskbit(offsetof(bool_expr__LogicalAnd, right));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__LogicalAnd)
};

class bool_expr__LogicalOr : public bool_expr_t {
 public:
  bool_expr__LogicalOr()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalOr),
                      field_mask(), sizeof(bool_expr__LogicalOr)),
        left(nullptr),
        right(nullptr) {
  }

  bool_expr__LogicalOr(bool_expr_t* left, bool_expr_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(bool_expr_e::LogicalOr),
                      field_mask(), sizeof(bool_expr__LogicalOr)),
        left(left),
        right(right) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool_expr_t* left;
  bool_expr_t* right;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(bool_expr__LogicalOr, left))
         | maskbit(offsetof(bool_expr__LogicalOr, right));
  }

  DISALLOW_COPY_AND_ASSIGN(bool_expr__LogicalOr)
};

namespace bool_expr {
  typedef bool_expr__WordTest WordTest;
  typedef bool_expr__Binary Binary;
  typedef bool_expr__Unary Unary;
  typedef bool_expr__LogicalNot LogicalNot;
  typedef bool_expr__LogicalAnd LogicalAnd;
  typedef bool_expr__LogicalOr LogicalOr;
}

namespace redir_loc_e {
  const int Fd = 1;
  const int VarName = 2;
};

const char* redir_loc_str(int tag);

class redir_loc_t {
 protected:
  redir_loc_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(redir_loc_t)
};

class redir_loc__Fd : public redir_loc_t {
 public:
  redir_loc__Fd()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_loc_e::Fd),
                      kZeroMask, sizeof(redir_loc__Fd)),
        fd(-1) {
  }

  redir_loc__Fd(int fd)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_loc_e::Fd),
                      kZeroMask, sizeof(redir_loc__Fd)),
        fd(fd) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int fd;

  DISALLOW_COPY_AND_ASSIGN(redir_loc__Fd)
};

class redir_loc__VarName : public redir_loc_t {
 public:
  redir_loc__VarName()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_loc_e::VarName),
                      field_mask(), sizeof(redir_loc__VarName)),
        name(StrFromC("")) {
  }

  redir_loc__VarName(Str* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_loc_e::VarName),
                      field_mask(), sizeof(redir_loc__VarName)),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redir_loc__VarName, name));
  }

  DISALLOW_COPY_AND_ASSIGN(redir_loc__VarName)
};

namespace redir_loc {
  typedef redir_loc__Fd Fd;
  typedef redir_loc__VarName VarName;
}

namespace redir_param_e {
  const int Word = 74;
  const int HereDoc = 2;
};

const char* redir_param_str(int tag);

class redir_param_t {
 protected:
  redir_param_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(redir_param_t)
};

class redir_param__HereDoc : public redir_param_t {
 public:
  redir_param__HereDoc()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_param_e::HereDoc),
                      field_mask(), sizeof(redir_param__HereDoc)),
        here_begin(nullptr),
        here_end_span_id(-1),
        stdin_parts(NewList<word_part_t*>()) {
  }

  redir_param__HereDoc(word_t* here_begin, int here_end_span_id,
                       List<word_part_t*>* stdin_parts)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(redir_param_e::HereDoc),
                      field_mask(), sizeof(redir_param__HereDoc)),
        here_begin(here_begin),
        here_end_span_id(here_end_span_id),
        stdin_parts(stdin_parts) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  word_t* here_begin;
  int here_end_span_id;
  List<word_part_t*>* stdin_parts;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redir_param__HereDoc, here_begin))
         | maskbit(offsetof(redir_param__HereDoc, stdin_parts));
  }

  DISALLOW_COPY_AND_ASSIGN(redir_param__HereDoc)
};

namespace redir_param {
  typedef redir_param__HereDoc HereDoc;
}

enum class assign_op_e {
  Equal = 1,
  PlusEqual = 2,
};
typedef assign_op_e assign_op_t;

const char* assign_op_str(assign_op_e tag);

namespace condition_e {
  const int Shell = 1;
  const int Oil = 2;
};

const char* condition_str(int tag);

class condition_t {
 protected:
  condition_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(condition_t)
};

class condition__Shell : public condition_t {
 public:
  condition__Shell()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(condition_e::Shell),
                      field_mask(), sizeof(condition__Shell)),
        commands(NewList<command_t*>()) {
  }

  condition__Shell(List<command_t*>* commands)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(condition_e::Shell),
                      field_mask(), sizeof(condition__Shell)),
        commands(commands) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<command_t*>* commands;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(condition__Shell, commands));
  }

  DISALLOW_COPY_AND_ASSIGN(condition__Shell)
};

class condition__Oil : public condition_t {
 public:
  condition__Oil()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(condition_e::Oil),
                      field_mask(), sizeof(condition__Oil)),
        e(nullptr) {
  }

  condition__Oil(expr_t* e)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(condition_e::Oil),
                      field_mask(), sizeof(condition__Oil)),
        e(e) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* e;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(condition__Oil, e));
  }

  DISALLOW_COPY_AND_ASSIGN(condition__Oil)
};

namespace condition {
  typedef condition__Shell Shell;
  typedef condition__Oil Oil;
}

namespace for_iter_e {
  const int Args = 1;
  const int Words = 2;
  const int Oil = 3;
};

const char* for_iter_str(int tag);

class for_iter_t {
 protected:
  for_iter_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(for_iter_t)
};

class for_iter__Args : public for_iter_t {
 public:
  for_iter__Args()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(for_iter_e::Args),
                      kZeroMask, sizeof(for_iter__Args)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(for_iter__Args)
};

class for_iter__Words : public for_iter_t {
 public:
  for_iter__Words()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(for_iter_e::Words),
                      field_mask(), sizeof(for_iter__Words)),
        words(NewList<word_t*>()) {
  }

  for_iter__Words(List<word_t*>* words)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(for_iter_e::Words),
                      field_mask(), sizeof(for_iter__Words)),
        words(words) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<word_t*>* words;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(for_iter__Words, words));
  }

  DISALLOW_COPY_AND_ASSIGN(for_iter__Words)
};

class for_iter__Oil : public for_iter_t {
 public:
  for_iter__Oil()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(for_iter_e::Oil),
                      field_mask(), sizeof(for_iter__Oil)),
        e(nullptr),
        blame(nullptr) {
  }

  for_iter__Oil(expr_t* e, Token* blame)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(for_iter_e::Oil),
                      field_mask(), sizeof(for_iter__Oil)),
        e(e),
        blame(blame) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* e;
  Token* blame;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(for_iter__Oil, e))
         | maskbit(offsetof(for_iter__Oil, blame));
  }

  DISALLOW_COPY_AND_ASSIGN(for_iter__Oil)
};

namespace for_iter {
  typedef for_iter__Args Args;
  typedef for_iter__Words Words;
  typedef for_iter__Oil Oil;
}

namespace command_e {
  const int NoOp = 1;
  const int Simple = 2;
  const int ExpandedAlias = 3;
  const int Sentence = 4;
  const int ShAssignment = 5;
  const int ControlFlow = 6;
  const int Pipeline = 7;
  const int AndOr = 8;
  const int DoGroup = 9;
  const int BraceGroup = 82;
  const int Subshell = 11;
  const int DParen = 12;
  const int DBracket = 13;
  const int ForEach = 14;
  const int ForExpr = 15;
  const int WhileUntil = 16;
  const int If = 17;
  const int Case = 18;
  const int ShFunction = 19;
  const int TimeBlock = 20;
  const int CommandList = 21;
  const int BareDecl = 22;
  const int VarDecl = 23;
  const int PlaceMutation = 24;
  const int Expr = 25;
  const int Proc = 26;
  const int Func = 27;
  const int Data = 28;
  const int Enum = 29;
  const int Class = 30;
  const int Import = 31;
  const int For = 32;
  const int While = 33;
  const int Break = 34;
  const int Continue = 35;
  const int Return = 36;
};

const char* command_str(int tag);

class command_t {
 protected:
  command_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(command_t)
};

class command__NoOp : public command_t {
 public:
  command__NoOp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::NoOp),
                      field_mask(), sizeof(command__NoOp)),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__NoOp, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__NoOp)
};

class command__Simple : public command_t {
 public:
  command__Simple()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Simple),
                      field_mask(), sizeof(command__Simple)),
        words(NewList<word_t*>()),
        redirects(NewList<redir*>()),
        more_env(NewList<env_pair*>()),
        typed_args(nullptr),
        block(nullptr),
        do_fork(false),
        spids(NewList<int>()) {
  }

  command__Simple(List<word_t*>* words, List<redir*>* redirects,
                  List<env_pair*>* more_env, ArgList* typed_args, BraceGroup*
                  block, bool do_fork)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Simple),
                      field_mask(), sizeof(command__Simple)),
        words(words),
        redirects(redirects),
        more_env(more_env),
        typed_args(typed_args),
        block(block),
        do_fork(do_fork),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<word_t*>* words;
  List<redir*>* redirects;
  List<env_pair*>* more_env;
  ArgList* typed_args;
  BraceGroup* block;
  bool do_fork;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Simple, words))
         | maskbit(offsetof(command__Simple, redirects))
         | maskbit(offsetof(command__Simple, more_env))
         | maskbit(offsetof(command__Simple, typed_args))
         | maskbit(offsetof(command__Simple, block))
         | maskbit(offsetof(command__Simple, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Simple)
};

class command__ExpandedAlias : public command_t {
 public:
  command__ExpandedAlias()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ExpandedAlias),
                      field_mask(), sizeof(command__ExpandedAlias)),
        child(nullptr),
        redirects(NewList<redir*>()),
        more_env(NewList<env_pair*>()),
        spids(NewList<int>()) {
  }

  command__ExpandedAlias(command_t* child, List<redir*>* redirects,
                         List<env_pair*>* more_env)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ExpandedAlias),
                      field_mask(), sizeof(command__ExpandedAlias)),
        child(child),
        redirects(redirects),
        more_env(more_env),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  command_t* child;
  List<redir*>* redirects;
  List<env_pair*>* more_env;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ExpandedAlias, child))
         | maskbit(offsetof(command__ExpandedAlias, redirects))
         | maskbit(offsetof(command__ExpandedAlias, more_env))
         | maskbit(offsetof(command__ExpandedAlias, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ExpandedAlias)
};

class command__Sentence : public command_t {
 public:
  command__Sentence()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Sentence),
                      field_mask(), sizeof(command__Sentence)),
        child(nullptr),
        terminator(nullptr),
        spids(NewList<int>()) {
  }

  command__Sentence(command_t* child, Token* terminator)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Sentence),
                      field_mask(), sizeof(command__Sentence)),
        child(child),
        terminator(terminator),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  command_t* child;
  Token* terminator;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Sentence, child))
         | maskbit(offsetof(command__Sentence, terminator))
         | maskbit(offsetof(command__Sentence, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Sentence)
};

class command__ShAssignment : public command_t {
 public:
  command__ShAssignment()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ShAssignment),
                      field_mask(), sizeof(command__ShAssignment)),
        pairs(NewList<assign_pair*>()),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__ShAssignment(List<assign_pair*>* pairs, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ShAssignment),
                      field_mask(), sizeof(command__ShAssignment)),
        pairs(pairs),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<assign_pair*>* pairs;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ShAssignment, pairs))
         | maskbit(offsetof(command__ShAssignment, redirects))
         | maskbit(offsetof(command__ShAssignment, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ShAssignment)
};

class command__ControlFlow : public command_t {
 public:
  command__ControlFlow()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ControlFlow),
                      field_mask(), sizeof(command__ControlFlow)),
        token(nullptr),
        arg_word(nullptr),
        spids(NewList<int>()) {
  }

  command__ControlFlow(Token* token, word_t* arg_word)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ControlFlow),
                      field_mask(), sizeof(command__ControlFlow)),
        token(token),
        arg_word(arg_word),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;
  word_t* arg_word;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ControlFlow, token))
         | maskbit(offsetof(command__ControlFlow, arg_word))
         | maskbit(offsetof(command__ControlFlow, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ControlFlow)
};

class command__Pipeline : public command_t {
 public:
  command__Pipeline()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Pipeline),
                      field_mask(), sizeof(command__Pipeline)),
        children(NewList<command_t*>()),
        negated(false),
        stderr_indices(NewList<int>()),
        spids(NewList<int>()) {
  }

  command__Pipeline(List<command_t*>* children, bool negated, List<int>*
                    stderr_indices)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Pipeline),
                      field_mask(), sizeof(command__Pipeline)),
        children(children),
        negated(negated),
        stderr_indices(stderr_indices),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<command_t*>* children;
  bool negated;
  List<int>* stderr_indices;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Pipeline, children))
         | maskbit(offsetof(command__Pipeline, stderr_indices))
         | maskbit(offsetof(command__Pipeline, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Pipeline)
};

class command__AndOr : public command_t {
 public:
  command__AndOr()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::AndOr),
                      field_mask(), sizeof(command__AndOr)),
        ops(NewList<Id_t>()),
        children(NewList<command_t*>()),
        spids(NewList<int>()) {
  }

  command__AndOr(List<Id_t>* ops, List<command_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::AndOr),
                      field_mask(), sizeof(command__AndOr)),
        ops(ops),
        children(children),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Id_t>* ops;
  List<command_t*>* children;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__AndOr, ops))
         | maskbit(offsetof(command__AndOr, children))
         | maskbit(offsetof(command__AndOr, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__AndOr)
};

class command__DoGroup : public command_t {
 public:
  command__DoGroup()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DoGroup),
                      field_mask(), sizeof(command__DoGroup)),
        children(NewList<command_t*>()),
        spids(NewList<int>()) {
  }

  command__DoGroup(List<command_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DoGroup),
                      field_mask(), sizeof(command__DoGroup)),
        children(children),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<command_t*>* children;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__DoGroup, children))
         | maskbit(offsetof(command__DoGroup, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__DoGroup)
};

class command__Subshell : public command_t {
 public:
  command__Subshell()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Subshell),
                      field_mask(), sizeof(command__Subshell)),
        child(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__Subshell(command_t* child, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Subshell),
                      field_mask(), sizeof(command__Subshell)),
        child(child),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  command_t* child;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Subshell, child))
         | maskbit(offsetof(command__Subshell, redirects))
         | maskbit(offsetof(command__Subshell, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Subshell)
};

class command__DParen : public command_t {
 public:
  command__DParen()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DParen),
                      field_mask(), sizeof(command__DParen)),
        child(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__DParen(arith_expr_t* child, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DParen),
                      field_mask(), sizeof(command__DParen)),
        child(child),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* child;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__DParen, child))
         | maskbit(offsetof(command__DParen, redirects))
         | maskbit(offsetof(command__DParen, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__DParen)
};

class command__DBracket : public command_t {
 public:
  command__DBracket()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DBracket),
                      field_mask(), sizeof(command__DBracket)),
        expr(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__DBracket(bool_expr_t* expr, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::DBracket),
                      field_mask(), sizeof(command__DBracket)),
        expr(expr),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool_expr_t* expr;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__DBracket, expr))
         | maskbit(offsetof(command__DBracket, redirects))
         | maskbit(offsetof(command__DBracket, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__DBracket)
};

class command__ForEach : public command_t {
 public:
  command__ForEach()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ForEach),
                      field_mask(), sizeof(command__ForEach)),
        iter_names(NewList<Str*>()),
        iterable(nullptr),
        body(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__ForEach(List<Str*>* iter_names, for_iter_t* iterable, command_t*
                   body, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ForEach),
                      field_mask(), sizeof(command__ForEach)),
        iter_names(iter_names),
        iterable(iterable),
        body(body),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Str*>* iter_names;
  for_iter_t* iterable;
  command_t* body;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ForEach, iter_names))
         | maskbit(offsetof(command__ForEach, iterable))
         | maskbit(offsetof(command__ForEach, body))
         | maskbit(offsetof(command__ForEach, redirects))
         | maskbit(offsetof(command__ForEach, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ForEach)
};

class command__ForExpr : public command_t {
 public:
  command__ForExpr()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ForExpr),
                      field_mask(), sizeof(command__ForExpr)),
        init(nullptr),
        cond(nullptr),
        update(nullptr),
        body(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__ForExpr(arith_expr_t* init, arith_expr_t* cond, arith_expr_t*
                   update, command_t* body, List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ForExpr),
                      field_mask(), sizeof(command__ForExpr)),
        init(init),
        cond(cond),
        update(update),
        body(body),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  arith_expr_t* init;
  arith_expr_t* cond;
  arith_expr_t* update;
  command_t* body;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ForExpr, init))
         | maskbit(offsetof(command__ForExpr, cond))
         | maskbit(offsetof(command__ForExpr, update))
         | maskbit(offsetof(command__ForExpr, body))
         | maskbit(offsetof(command__ForExpr, redirects))
         | maskbit(offsetof(command__ForExpr, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ForExpr)
};

class command__WhileUntil : public command_t {
 public:
  command__WhileUntil()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::WhileUntil),
                      field_mask(), sizeof(command__WhileUntil)),
        keyword(nullptr),
        cond(nullptr),
        body(nullptr),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__WhileUntil(Token* keyword, condition_t* cond, command_t* body,
                      List<redir*>* redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::WhileUntil),
                      field_mask(), sizeof(command__WhileUntil)),
        keyword(keyword),
        cond(cond),
        body(body),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* keyword;
  condition_t* cond;
  command_t* body;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__WhileUntil, keyword))
         | maskbit(offsetof(command__WhileUntil, cond))
         | maskbit(offsetof(command__WhileUntil, body))
         | maskbit(offsetof(command__WhileUntil, redirects))
         | maskbit(offsetof(command__WhileUntil, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__WhileUntil)
};

class command__If : public command_t {
 public:
  command__If()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::If),
                      field_mask(), sizeof(command__If)),
        arms(NewList<if_arm*>()),
        else_action(NewList<command_t*>()),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__If(List<if_arm*>* arms, List<command_t*>* else_action, List<redir*>*
              redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::If),
                      field_mask(), sizeof(command__If)),
        arms(arms),
        else_action(else_action),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<if_arm*>* arms;
  List<command_t*>* else_action;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__If, arms))
         | maskbit(offsetof(command__If, else_action))
         | maskbit(offsetof(command__If, redirects))
         | maskbit(offsetof(command__If, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__If)
};

class command__Case : public command_t {
 public:
  command__Case()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Case),
                      field_mask(), sizeof(command__Case)),
        to_match(nullptr),
        arms(NewList<case_arm*>()),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  command__Case(word_t* to_match, List<case_arm*>* arms, List<redir*>*
                redirects)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Case),
                      field_mask(), sizeof(command__Case)),
        to_match(to_match),
        arms(arms),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  word_t* to_match;
  List<case_arm*>* arms;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Case, to_match))
         | maskbit(offsetof(command__Case, arms))
         | maskbit(offsetof(command__Case, redirects))
         | maskbit(offsetof(command__Case, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Case)
};

class command__ShFunction : public command_t {
 public:
  command__ShFunction()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ShFunction),
                      field_mask(), sizeof(command__ShFunction)),
        name(StrFromC("")),
        body(nullptr),
        spids(NewList<int>()) {
  }

  command__ShFunction(Str* name, command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::ShFunction),
                      field_mask(), sizeof(command__ShFunction)),
        name(name),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  command_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__ShFunction, name))
         | maskbit(offsetof(command__ShFunction, body))
         | maskbit(offsetof(command__ShFunction, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__ShFunction)
};

class command__TimeBlock : public command_t {
 public:
  command__TimeBlock()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::TimeBlock),
                      field_mask(), sizeof(command__TimeBlock)),
        pipeline(nullptr),
        spids(NewList<int>()) {
  }

  command__TimeBlock(command_t* pipeline)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::TimeBlock),
                      field_mask(), sizeof(command__TimeBlock)),
        pipeline(pipeline),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  command_t* pipeline;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__TimeBlock, pipeline))
         | maskbit(offsetof(command__TimeBlock, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__TimeBlock)
};

class command__CommandList : public command_t {
 public:
  command__CommandList()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::CommandList),
                      field_mask(), sizeof(command__CommandList)),
        children(NewList<command_t*>()),
        spids(NewList<int>()) {
  }

  command__CommandList(List<command_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::CommandList),
                      field_mask(), sizeof(command__CommandList)),
        children(children),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<command_t*>* children;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__CommandList, children))
         | maskbit(offsetof(command__CommandList, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__CommandList)
};

class command__BareDecl : public command_t {
 public:
  command__BareDecl()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::BareDecl),
                      field_mask(), sizeof(command__BareDecl)),
        lhs(nullptr),
        rhs(nullptr),
        spids(NewList<int>()) {
  }

  command__BareDecl(Token* lhs, expr_t* rhs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::BareDecl),
                      field_mask(), sizeof(command__BareDecl)),
        lhs(lhs),
        rhs(rhs),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* lhs;
  expr_t* rhs;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__BareDecl, lhs))
         | maskbit(offsetof(command__BareDecl, rhs))
         | maskbit(offsetof(command__BareDecl, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__BareDecl)
};

class command__VarDecl : public command_t {
 public:
  command__VarDecl()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::VarDecl),
                      field_mask(), sizeof(command__VarDecl)),
        keyword(nullptr),
        lhs(NewList<name_type*>()),
        rhs(nullptr),
        spids(NewList<int>()) {
  }

  command__VarDecl(Token* keyword, List<name_type*>* lhs, expr_t* rhs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::VarDecl),
                      field_mask(), sizeof(command__VarDecl)),
        keyword(keyword),
        lhs(lhs),
        rhs(rhs),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* keyword;
  List<name_type*>* lhs;
  expr_t* rhs;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__VarDecl, keyword))
         | maskbit(offsetof(command__VarDecl, lhs))
         | maskbit(offsetof(command__VarDecl, rhs))
         | maskbit(offsetof(command__VarDecl, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__VarDecl)
};

class command__PlaceMutation : public command_t {
 public:
  command__PlaceMutation()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::PlaceMutation),
                      field_mask(), sizeof(command__PlaceMutation)),
        keyword(nullptr),
        lhs(NewList<place_expr_t*>()),
        op(nullptr),
        rhs(nullptr),
        spids(NewList<int>()) {
  }

  command__PlaceMutation(Token* keyword, List<place_expr_t*>* lhs, Token* op,
                         expr_t* rhs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::PlaceMutation),
                      field_mask(), sizeof(command__PlaceMutation)),
        keyword(keyword),
        lhs(lhs),
        op(op),
        rhs(rhs),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* keyword;
  List<place_expr_t*>* lhs;
  Token* op;
  expr_t* rhs;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__PlaceMutation, keyword))
         | maskbit(offsetof(command__PlaceMutation, lhs))
         | maskbit(offsetof(command__PlaceMutation, op))
         | maskbit(offsetof(command__PlaceMutation, rhs))
         | maskbit(offsetof(command__PlaceMutation, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__PlaceMutation)
};

class command__Expr : public command_t {
 public:
  command__Expr()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Expr),
                      field_mask(), sizeof(command__Expr)),
        keyword(nullptr),
        e(nullptr),
        spids(NewList<int>()) {
  }

  command__Expr(speck* keyword, expr_t* e)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Expr),
                      field_mask(), sizeof(command__Expr)),
        keyword(keyword),
        e(e),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  speck* keyword;
  expr_t* e;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Expr, keyword))
         | maskbit(offsetof(command__Expr, e))
         | maskbit(offsetof(command__Expr, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Expr)
};

class command__Proc : public command_t {
 public:
  command__Proc()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Proc),
                      field_mask(), sizeof(command__Proc)),
        name(nullptr),
        sig(nullptr),
        body(nullptr),
        spids(NewList<int>()) {
  }

  command__Proc(Token* name, proc_sig_t* sig, command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Proc),
                      field_mask(), sizeof(command__Proc)),
        name(name),
        sig(sig),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  proc_sig_t* sig;
  command_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Proc, name))
         | maskbit(offsetof(command__Proc, sig))
         | maskbit(offsetof(command__Proc, body))
         | maskbit(offsetof(command__Proc, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Proc)
};

class command__Func : public command_t {
 public:
  command__Func()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Func),
                      field_mask(), sizeof(command__Func)),
        name(nullptr),
        pos_params(NewList<param*>()),
        pos_splat(nullptr),
        named_params(NewList<param*>()),
        named_splat(nullptr),
        return_types(NewList<type_expr_t*>()),
        body(nullptr),
        spids(NewList<int>()) {
  }

  command__Func(Token* name, List<param*>* pos_params, Token* pos_splat,
                List<param*>* named_params, Token* named_splat,
                List<type_expr_t*>* return_types, command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Func),
                      field_mask(), sizeof(command__Func)),
        name(name),
        pos_params(pos_params),
        pos_splat(pos_splat),
        named_params(named_params),
        named_splat(named_splat),
        return_types(return_types),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<param*>* pos_params;
  Token* pos_splat;
  List<param*>* named_params;
  Token* named_splat;
  List<type_expr_t*>* return_types;
  command_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Func, name))
         | maskbit(offsetof(command__Func, pos_params))
         | maskbit(offsetof(command__Func, pos_splat))
         | maskbit(offsetof(command__Func, named_params))
         | maskbit(offsetof(command__Func, named_splat))
         | maskbit(offsetof(command__Func, return_types))
         | maskbit(offsetof(command__Func, body))
         | maskbit(offsetof(command__Func, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Func)
};

class command__Data : public command_t {
 public:
  command__Data()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Data),
                      field_mask(), sizeof(command__Data)),
        name(nullptr),
        params(NewList<param*>()),
        spids(NewList<int>()) {
  }

  command__Data(Token* name, List<param*>* params)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Data),
                      field_mask(), sizeof(command__Data)),
        name(name),
        params(params),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<param*>* params;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Data, name))
         | maskbit(offsetof(command__Data, params))
         | maskbit(offsetof(command__Data, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Data)
};

class command__Enum : public command_t {
 public:
  command__Enum()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Enum),
                      field_mask(), sizeof(command__Enum)),
        name(nullptr),
        variants(NewList<variant*>()),
        spids(NewList<int>()) {
  }

  command__Enum(Token* name, List<variant*>* variants)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Enum),
                      field_mask(), sizeof(command__Enum)),
        name(name),
        variants(variants),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<variant*>* variants;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Enum, name))
         | maskbit(offsetof(command__Enum, variants))
         | maskbit(offsetof(command__Enum, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Enum)
};

class command__Class : public command_t {
 public:
  command__Class()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Class),
                      field_mask(), sizeof(command__Class)),
        name(nullptr),
        extends(nullptr),
        items(NewList<class_item_t*>()),
        spids(NewList<int>()) {
  }

  command__Class(Token* name, Token* extends, List<class_item_t*>* items)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Class),
                      field_mask(), sizeof(command__Class)),
        name(name),
        extends(extends),
        items(items),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  Token* extends;
  List<class_item_t*>* items;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Class, name))
         | maskbit(offsetof(command__Class, extends))
         | maskbit(offsetof(command__Class, items))
         | maskbit(offsetof(command__Class, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Class)
};

class command__Import : public command_t {
 public:
  command__Import()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Import),
                      field_mask(), sizeof(command__Import)),
        path(nullptr),
        alias(nullptr),
        names(NewList<import_name*>()),
        spids(NewList<int>()) {
  }

  command__Import(single_quoted* path, Token* alias, List<import_name*>* names)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Import),
                      field_mask(), sizeof(command__Import)),
        path(path),
        alias(alias),
        names(names),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  single_quoted* path;
  Token* alias;
  List<import_name*>* names;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Import, path))
         | maskbit(offsetof(command__Import, alias))
         | maskbit(offsetof(command__Import, names))
         | maskbit(offsetof(command__Import, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Import)
};

class command__For : public command_t {
 public:
  command__For()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::For),
                      field_mask(), sizeof(command__For)),
        targets(NewList<name_type*>()),
        iterable(nullptr),
        body(nullptr),
        spids(NewList<int>()) {
  }

  command__For(List<name_type*>* targets, expr_t* iterable, command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::For),
                      field_mask(), sizeof(command__For)),
        targets(targets),
        iterable(iterable),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<name_type*>* targets;
  expr_t* iterable;
  command_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__For, targets))
         | maskbit(offsetof(command__For, iterable))
         | maskbit(offsetof(command__For, body))
         | maskbit(offsetof(command__For, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__For)
};

class command__While : public command_t {
 public:
  command__While()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::While),
                      field_mask(), sizeof(command__While)),
        test(nullptr),
        body(nullptr),
        spids(NewList<int>()) {
  }

  command__While(expr_t* test, command_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::While),
                      field_mask(), sizeof(command__While)),
        test(test),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* test;
  command_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__While, test))
         | maskbit(offsetof(command__While, body))
         | maskbit(offsetof(command__While, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__While)
};

class command__Break : public command_t {
 public:
  command__Break()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Break),
                      field_mask(), sizeof(command__Break)),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Break, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Break)
};

class command__Continue : public command_t {
 public:
  command__Continue()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Continue),
                      field_mask(), sizeof(command__Continue)),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Continue, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Continue)
};

class command__Return : public command_t {
 public:
  command__Return()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Return),
                      field_mask(), sizeof(command__Return)),
        value(nullptr),
        spids(NewList<int>()) {
  }

  command__Return(expr_t* value)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(command_e::Return),
                      field_mask(), sizeof(command__Return)),
        value(value),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* value;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command__Return, value))
         | maskbit(offsetof(command__Return, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command__Return)
};

namespace command {
  typedef command__NoOp NoOp;
  typedef command__Simple Simple;
  typedef command__ExpandedAlias ExpandedAlias;
  typedef command__Sentence Sentence;
  typedef command__ShAssignment ShAssignment;
  typedef command__ControlFlow ControlFlow;
  typedef command__Pipeline Pipeline;
  typedef command__AndOr AndOr;
  typedef command__DoGroup DoGroup;
  typedef command__Subshell Subshell;
  typedef command__DParen DParen;
  typedef command__DBracket DBracket;
  typedef command__ForEach ForEach;
  typedef command__ForExpr ForExpr;
  typedef command__WhileUntil WhileUntil;
  typedef command__If If;
  typedef command__Case Case;
  typedef command__ShFunction ShFunction;
  typedef command__TimeBlock TimeBlock;
  typedef command__CommandList CommandList;
  typedef command__BareDecl BareDecl;
  typedef command__VarDecl VarDecl;
  typedef command__PlaceMutation PlaceMutation;
  typedef command__Expr Expr;
  typedef command__Proc Proc;
  typedef command__Func Func;
  typedef command__Data Data;
  typedef command__Enum Enum;
  typedef command__Class Class;
  typedef command__Import Import;
  typedef command__For For;
  typedef command__While While;
  typedef command__Break Break;
  typedef command__Continue Continue;
  typedef command__Return Return;
}

namespace variant_type_e {
  const int Anon = 1;
  const int Ref = 2;
};

const char* variant_type_str(int tag);

class variant_type_t {
 protected:
  variant_type_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(variant_type_t)
};

class variant_type__Anon : public variant_type_t {
 public:
  variant_type__Anon()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(variant_type_e::Anon),
                      field_mask(), sizeof(variant_type__Anon)),
        params(NewList<param*>()) {
  }

  variant_type__Anon(List<param*>* params)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(variant_type_e::Anon),
                      field_mask(), sizeof(variant_type__Anon)),
        params(params) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<param*>* params;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(variant_type__Anon, params));
  }

  DISALLOW_COPY_AND_ASSIGN(variant_type__Anon)
};

class variant_type__Ref : public variant_type_t {
 public:
  variant_type__Ref()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(variant_type_e::Ref),
                      field_mask(), sizeof(variant_type__Ref)),
        type_name(nullptr) {
  }

  variant_type__Ref(Token* type_name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(variant_type_e::Ref),
                      field_mask(), sizeof(variant_type__Ref)),
        type_name(type_name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* type_name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(variant_type__Ref, type_name));
  }

  DISALLOW_COPY_AND_ASSIGN(variant_type__Ref)
};

namespace variant_type {
  typedef variant_type__Anon Anon;
  typedef variant_type__Ref Ref;
}

namespace class_item_e {
  const int Data = 1;
  const int Method = 2;
};

const char* class_item_str(int tag);

class class_item_t {
 protected:
  class_item_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(class_item_t)
};

class class_item__Data : public class_item_t {
 public:
  class_item__Data()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_item_e::Data),
                      field_mask(), sizeof(class_item__Data)),
        keyword(nullptr),
        fields(NewList<name_type*>()) {
  }

  class_item__Data(Token* keyword, List<name_type*>* fields)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_item_e::Data),
                      field_mask(), sizeof(class_item__Data)),
        keyword(keyword),
        fields(fields) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* keyword;
  List<name_type*>* fields;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(class_item__Data, keyword))
         | maskbit(offsetof(class_item__Data, fields));
  }

  DISALLOW_COPY_AND_ASSIGN(class_item__Data)
};

class class_item__Method : public class_item_t {
 public:
  class_item__Method()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_item_e::Method),
                      kZeroMask, sizeof(class_item__Method)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(class_item__Method)
};

namespace class_item {
  typedef class_item__Data Data;
  typedef class_item__Method Method;
}

namespace proc_sig_e {
  const int Open = 1;
  const int Closed = 2;
};

const char* proc_sig_str(int tag);

class proc_sig_t {
 protected:
  proc_sig_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(proc_sig_t)
};

class proc_sig__Open : public proc_sig_t {
 public:
  proc_sig__Open()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(proc_sig_e::Open),
                      kZeroMask, sizeof(proc_sig__Open)) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);

  DISALLOW_COPY_AND_ASSIGN(proc_sig__Open)
};

class proc_sig__Closed : public proc_sig_t {
 public:
  proc_sig__Closed()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(proc_sig_e::Closed),
                      field_mask(), sizeof(proc_sig__Closed)),
        untyped(NewList<UntypedParam*>()),
        rest(nullptr),
        typed(NewList<TypedParam*>()) {
  }

  proc_sig__Closed(List<UntypedParam*>* untyped, Token* rest,
                   List<TypedParam*>* typed)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(proc_sig_e::Closed),
                      field_mask(), sizeof(proc_sig__Closed)),
        untyped(untyped),
        rest(rest),
        typed(typed) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<UntypedParam*>* untyped;
  Token* rest;
  List<TypedParam*>* typed;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(proc_sig__Closed, untyped))
         | maskbit(offsetof(proc_sig__Closed, rest))
         | maskbit(offsetof(proc_sig__Closed, typed));
  }

  DISALLOW_COPY_AND_ASSIGN(proc_sig__Closed)
};

namespace proc_sig {
  typedef proc_sig__Open Open;
  typedef proc_sig__Closed Closed;
}

namespace glob_part_e {
  const int Literal = 1;
  const int Operator = 2;
  const int CharClass = 3;
};

const char* glob_part_str(int tag);

class glob_part_t {
 protected:
  glob_part_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(glob_part_t)
};

class glob_part__Literal : public glob_part_t {
 public:
  glob_part__Literal()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::Literal),
                      field_mask(), sizeof(glob_part__Literal)),
        id(-1),
        s(StrFromC("")) {
  }

  glob_part__Literal(Id_t id, Str* s)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::Literal),
                      field_mask(), sizeof(glob_part__Literal)),
        id(id),
        s(s) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t id;
  Str* s;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(glob_part__Literal, s));
  }

  DISALLOW_COPY_AND_ASSIGN(glob_part__Literal)
};

class glob_part__Operator : public glob_part_t {
 public:
  glob_part__Operator()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::Operator),
                      kZeroMask, sizeof(glob_part__Operator)),
        op_id(-1) {
  }

  glob_part__Operator(Id_t op_id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::Operator),
                      kZeroMask, sizeof(glob_part__Operator)),
        op_id(op_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t op_id;

  DISALLOW_COPY_AND_ASSIGN(glob_part__Operator)
};

class glob_part__CharClass : public glob_part_t {
 public:
  glob_part__CharClass()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::CharClass),
                      field_mask(), sizeof(glob_part__CharClass)),
        negated(false),
        strs(NewList<Str*>()) {
  }

  glob_part__CharClass(bool negated, List<Str*>* strs)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(glob_part_e::CharClass),
                      field_mask(), sizeof(glob_part__CharClass)),
        negated(negated),
        strs(strs) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool negated;
  List<Str*>* strs;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(glob_part__CharClass, strs));
  }

  DISALLOW_COPY_AND_ASSIGN(glob_part__CharClass)
};

namespace glob_part {
  typedef glob_part__Literal Literal;
  typedef glob_part__Operator Operator;
  typedef glob_part__CharClass CharClass;
}

namespace printf_part_e {
  const int Literal = 1;
  const int Percent = 2;
};

const char* printf_part_str(int tag);

class printf_part_t {
 protected:
  printf_part_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(printf_part_t)
};

class printf_part__Literal : public printf_part_t {
 public:
  printf_part__Literal()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(printf_part_e::Literal),
                      field_mask(), sizeof(printf_part__Literal)),
        token(nullptr) {
  }

  printf_part__Literal(Token* token)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(printf_part_e::Literal),
                      field_mask(), sizeof(printf_part__Literal)),
        token(token) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(printf_part__Literal, token));
  }

  DISALLOW_COPY_AND_ASSIGN(printf_part__Literal)
};

class printf_part__Percent : public printf_part_t {
 public:
  printf_part__Percent()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(printf_part_e::Percent),
                      field_mask(), sizeof(printf_part__Percent)),
        flags(NewList<Token*>()),
        width(nullptr),
        precision(nullptr),
        type(nullptr) {
  }

  printf_part__Percent(List<Token*>* flags, Token* width, Token* precision,
                       Token* type)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(printf_part_e::Percent),
                      field_mask(), sizeof(printf_part__Percent)),
        flags(flags),
        width(width),
        precision(precision),
        type(type) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<Token*>* flags;
  Token* width;
  Token* precision;
  Token* type;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(printf_part__Percent, flags))
         | maskbit(offsetof(printf_part__Percent, width))
         | maskbit(offsetof(printf_part__Percent, precision))
         | maskbit(offsetof(printf_part__Percent, type));
  }

  DISALLOW_COPY_AND_ASSIGN(printf_part__Percent)
};

namespace printf_part {
  typedef printf_part__Literal Literal;
  typedef printf_part__Percent Percent;
}

enum class expr_context_e {
  Load = 1,
  Store = 2,
  Del = 3,
  AugLoad = 4,
  AugStore = 5,
  Param = 6,
};
typedef expr_context_e expr_context_t;

const char* expr_context_str(expr_context_e tag);

namespace type_expr_e {
  const int Simple = 1;
  const int Compound = 2;
};

const char* type_expr_str(int tag);

class type_expr_t {
 protected:
  type_expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(type_expr_t)
};

class type_expr__Simple : public type_expr_t {
 public:
  type_expr__Simple()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(type_expr_e::Simple),
                      field_mask(), sizeof(type_expr__Simple)),
        name(nullptr) {
  }

  type_expr__Simple(Token* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(type_expr_e::Simple),
                      field_mask(), sizeof(type_expr__Simple)),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(type_expr__Simple, name));
  }

  DISALLOW_COPY_AND_ASSIGN(type_expr__Simple)
};

class type_expr__Compound : public type_expr_t {
 public:
  type_expr__Compound()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(type_expr_e::Compound),
                      field_mask(), sizeof(type_expr__Compound)),
        name(nullptr),
        params(NewList<type_expr_t*>()) {
  }

  type_expr__Compound(Token* name, List<type_expr_t*>* params)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(type_expr_e::Compound),
                      field_mask(), sizeof(type_expr__Compound)),
        name(name),
        params(params) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<type_expr_t*>* params;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(type_expr__Compound, name))
         | maskbit(offsetof(type_expr__Compound, params));
  }

  DISALLOW_COPY_AND_ASSIGN(type_expr__Compound)
};

namespace type_expr {
  typedef type_expr__Simple Simple;
  typedef type_expr__Compound Compound;
}

namespace place_expr_e {
  const int Var = 1;
  const int Subscript = 91;
  const int Attribute = 92;
};

const char* place_expr_str(int tag);

class place_expr_t {
 protected:
  place_expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(place_expr_t)
};

class place_expr__Var : public place_expr_t {
 public:
  place_expr__Var()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(place_expr_e::Var),
                      field_mask(), sizeof(place_expr__Var)),
        name(nullptr) {
  }

  place_expr__Var(Token* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(place_expr_e::Var),
                      field_mask(), sizeof(place_expr__Var)),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(place_expr__Var, name));
  }

  DISALLOW_COPY_AND_ASSIGN(place_expr__Var)
};

namespace place_expr {
  typedef place_expr__Var Var;
}

namespace expr_e {
  const int Var = 1;
  const int Const = 2;
  const int ShArrayLiteral = 72;
  const int RegexLiteral = 4;
  const int SimpleVarSub = 69;
  const int BracedVarSub = 70;
  const int CommandSub = 71;
  const int SingleQuoted = 68;
  const int DoubleQuoted = 67;
  const int BlockArg = 10;
  const int Lambda = 11;
  const int Unary = 12;
  const int Binary = 13;
  const int Compare = 14;
  const int FuncCall = 15;
  const int IfExp = 16;
  const int Tuple = 17;
  const int List = 18;
  const int Dict = 19;
  const int Implicit = 20;
  const int ListComp = 21;
  const int DictComp = 22;
  const int GeneratorExp = 23;
  const int Range = 24;
  const int Slice = 25;
  const int Subscript = 91;
  const int Attribute = 92;
  const int Spread = 28;
};

const char* expr_str(int tag);

class expr_t {
 protected:
  expr_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(expr_t)
};

class expr__Var : public expr_t {
 public:
  expr__Var()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Var),
                      field_mask(), sizeof(expr__Var)),
        name(nullptr),
        spids(NewList<int>()) {
  }

  expr__Var(Token* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Var),
                      field_mask(), sizeof(expr__Var)),
        name(name),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Var, name))
         | maskbit(offsetof(expr__Var, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Var)
};

class expr__Const : public expr_t {
 public:
  expr__Const()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Const),
                      field_mask(), sizeof(expr__Const)),
        c(nullptr),
        spids(NewList<int>()) {
  }

  expr__Const(Token* c)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Const),
                      field_mask(), sizeof(expr__Const)),
        c(c),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* c;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Const, c))
         | maskbit(offsetof(expr__Const, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Const)
};

class expr__RegexLiteral : public expr_t {
 public:
  expr__RegexLiteral()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::RegexLiteral),
                      field_mask(), sizeof(expr__RegexLiteral)),
        left(nullptr),
        regex(nullptr),
        flags(NewList<Token*>()),
        trans_pref(nullptr),
        spids(NewList<int>()) {
  }

  expr__RegexLiteral(Token* left, re_t* regex, List<Token*>* flags, Token*
                     trans_pref)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::RegexLiteral),
                      field_mask(), sizeof(expr__RegexLiteral)),
        left(left),
        regex(regex),
        flags(flags),
        trans_pref(trans_pref),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  re_t* regex;
  List<Token*>* flags;
  Token* trans_pref;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__RegexLiteral, left))
         | maskbit(offsetof(expr__RegexLiteral, regex))
         | maskbit(offsetof(expr__RegexLiteral, flags))
         | maskbit(offsetof(expr__RegexLiteral, trans_pref))
         | maskbit(offsetof(expr__RegexLiteral, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__RegexLiteral)
};

class expr__BlockArg : public expr_t {
 public:
  expr__BlockArg()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::BlockArg),
                      field_mask(), sizeof(expr__BlockArg)),
        block(nullptr),
        spids(NewList<int>()) {
  }

  expr__BlockArg(BraceGroup* block)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::BlockArg),
                      field_mask(), sizeof(expr__BlockArg)),
        block(block),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  BraceGroup* block;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__BlockArg, block))
         | maskbit(offsetof(expr__BlockArg, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__BlockArg)
};

class expr__Lambda : public expr_t {
 public:
  expr__Lambda()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Lambda),
                      field_mask(), sizeof(expr__Lambda)),
        params(NewList<name_type*>()),
        body(nullptr),
        spids(NewList<int>()) {
  }

  expr__Lambda(List<name_type*>* params, expr_t* body)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Lambda),
                      field_mask(), sizeof(expr__Lambda)),
        params(params),
        body(body),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<name_type*>* params;
  expr_t* body;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Lambda, params))
         | maskbit(offsetof(expr__Lambda, body))
         | maskbit(offsetof(expr__Lambda, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Lambda)
};

class expr__Unary : public expr_t {
 public:
  expr__Unary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Unary),
                      field_mask(), sizeof(expr__Unary)),
        op(nullptr),
        child(nullptr),
        spids(NewList<int>()) {
  }

  expr__Unary(Token* op, expr_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Unary),
                      field_mask(), sizeof(expr__Unary)),
        op(op),
        child(child),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* op;
  expr_t* child;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Unary, op))
         | maskbit(offsetof(expr__Unary, child))
         | maskbit(offsetof(expr__Unary, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Unary)
};

class expr__Binary : public expr_t {
 public:
  expr__Binary()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Binary),
                      field_mask(), sizeof(expr__Binary)),
        op(nullptr),
        left(nullptr),
        right(nullptr),
        spids(NewList<int>()) {
  }

  expr__Binary(Token* op, expr_t* left, expr_t* right)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Binary),
                      field_mask(), sizeof(expr__Binary)),
        op(op),
        left(left),
        right(right),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* op;
  expr_t* left;
  expr_t* right;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Binary, op))
         | maskbit(offsetof(expr__Binary, left))
         | maskbit(offsetof(expr__Binary, right))
         | maskbit(offsetof(expr__Binary, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Binary)
};

class expr__Compare : public expr_t {
 public:
  expr__Compare()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Compare),
                      field_mask(), sizeof(expr__Compare)),
        left(nullptr),
        ops(NewList<speck*>()),
        comparators(NewList<expr_t*>()),
        spids(NewList<int>()) {
  }

  expr__Compare(expr_t* left, List<speck*>* ops, List<expr_t*>* comparators)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Compare),
                      field_mask(), sizeof(expr__Compare)),
        left(left),
        ops(ops),
        comparators(comparators),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* left;
  List<speck*>* ops;
  List<expr_t*>* comparators;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Compare, left))
         | maskbit(offsetof(expr__Compare, ops))
         | maskbit(offsetof(expr__Compare, comparators))
         | maskbit(offsetof(expr__Compare, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Compare)
};

class expr__FuncCall : public expr_t {
 public:
  expr__FuncCall()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::FuncCall),
                      field_mask(), sizeof(expr__FuncCall)),
        func(nullptr),
        args(nullptr),
        spids(NewList<int>()) {
  }

  expr__FuncCall(expr_t* func, ArgList* args)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::FuncCall),
                      field_mask(), sizeof(expr__FuncCall)),
        func(func),
        args(args),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* func;
  ArgList* args;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__FuncCall, func))
         | maskbit(offsetof(expr__FuncCall, args))
         | maskbit(offsetof(expr__FuncCall, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__FuncCall)
};

class expr__IfExp : public expr_t {
 public:
  expr__IfExp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::IfExp),
                      field_mask(), sizeof(expr__IfExp)),
        test(nullptr),
        body(nullptr),
        orelse(nullptr),
        spids(NewList<int>()) {
  }

  expr__IfExp(expr_t* test, expr_t* body, expr_t* orelse)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::IfExp),
                      field_mask(), sizeof(expr__IfExp)),
        test(test),
        body(body),
        orelse(orelse),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* test;
  expr_t* body;
  expr_t* orelse;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__IfExp, test))
         | maskbit(offsetof(expr__IfExp, body))
         | maskbit(offsetof(expr__IfExp, orelse))
         | maskbit(offsetof(expr__IfExp, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__IfExp)
};

class expr__Tuple : public expr_t {
 public:
  expr__Tuple()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Tuple),
                      field_mask(), sizeof(expr__Tuple)),
        elts(NewList<expr_t*>()),
        ctx(expr_context_e::Load),
        spids(NewList<int>()) {
  }

  expr__Tuple(List<expr_t*>* elts, expr_context_t ctx)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Tuple),
                      field_mask(), sizeof(expr__Tuple)),
        elts(elts),
        ctx(ctx),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<expr_t*>* elts;
  expr_context_t ctx;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Tuple, elts))
         | maskbit(offsetof(expr__Tuple, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Tuple)
};

class expr__List : public expr_t {
 public:
  expr__List()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::List),
                      field_mask(), sizeof(expr__List)),
        elts(NewList<expr_t*>()),
        ctx(expr_context_e::Load),
        spids(NewList<int>()) {
  }

  expr__List(List<expr_t*>* elts, expr_context_t ctx)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::List),
                      field_mask(), sizeof(expr__List)),
        elts(elts),
        ctx(ctx),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<expr_t*>* elts;
  expr_context_t ctx;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__List, elts))
         | maskbit(offsetof(expr__List, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__List)
};

class expr__Dict : public expr_t {
 public:
  expr__Dict()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Dict),
                      field_mask(), sizeof(expr__Dict)),
        keys(NewList<expr_t*>()),
        values(NewList<expr_t*>()),
        spids(NewList<int>()) {
  }

  expr__Dict(List<expr_t*>* keys, List<expr_t*>* values)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Dict),
                      field_mask(), sizeof(expr__Dict)),
        keys(keys),
        values(values),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<expr_t*>* keys;
  List<expr_t*>* values;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Dict, keys))
         | maskbit(offsetof(expr__Dict, values))
         | maskbit(offsetof(expr__Dict, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Dict)
};

class expr__Implicit : public expr_t {
 public:
  expr__Implicit()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Implicit),
                      field_mask(), sizeof(expr__Implicit)),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Implicit, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Implicit)
};

class expr__ListComp : public expr_t {
 public:
  expr__ListComp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::ListComp),
                      field_mask(), sizeof(expr__ListComp)),
        elt(nullptr),
        generators(NewList<comprehension*>()),
        spids(NewList<int>()) {
  }

  expr__ListComp(expr_t* elt, List<comprehension*>* generators)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::ListComp),
                      field_mask(), sizeof(expr__ListComp)),
        elt(elt),
        generators(generators),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* elt;
  List<comprehension*>* generators;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__ListComp, elt))
         | maskbit(offsetof(expr__ListComp, generators))
         | maskbit(offsetof(expr__ListComp, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__ListComp)
};

class expr__DictComp : public expr_t {
 public:
  expr__DictComp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::DictComp),
                      field_mask(), sizeof(expr__DictComp)),
        key(nullptr),
        value(nullptr),
        generators(NewList<comprehension*>()),
        spids(NewList<int>()) {
  }

  expr__DictComp(expr_t* key, expr_t* value, List<comprehension*>* generators)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::DictComp),
                      field_mask(), sizeof(expr__DictComp)),
        key(key),
        value(value),
        generators(generators),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* key;
  expr_t* value;
  List<comprehension*>* generators;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__DictComp, key))
         | maskbit(offsetof(expr__DictComp, value))
         | maskbit(offsetof(expr__DictComp, generators))
         | maskbit(offsetof(expr__DictComp, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__DictComp)
};

class expr__GeneratorExp : public expr_t {
 public:
  expr__GeneratorExp()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::GeneratorExp),
                      field_mask(), sizeof(expr__GeneratorExp)),
        elt(nullptr),
        generators(NewList<comprehension*>()),
        spids(NewList<int>()) {
  }

  expr__GeneratorExp(expr_t* elt, List<comprehension*>* generators)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::GeneratorExp),
                      field_mask(), sizeof(expr__GeneratorExp)),
        elt(elt),
        generators(generators),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* elt;
  List<comprehension*>* generators;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__GeneratorExp, elt))
         | maskbit(offsetof(expr__GeneratorExp, generators))
         | maskbit(offsetof(expr__GeneratorExp, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__GeneratorExp)
};

class expr__Range : public expr_t {
 public:
  expr__Range()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Range),
                      field_mask(), sizeof(expr__Range)),
        lower(nullptr),
        upper(nullptr),
        spids(NewList<int>()) {
  }

  expr__Range(expr_t* lower, expr_t* upper)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Range),
                      field_mask(), sizeof(expr__Range)),
        lower(lower),
        upper(upper),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* lower;
  expr_t* upper;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Range, lower))
         | maskbit(offsetof(expr__Range, upper))
         | maskbit(offsetof(expr__Range, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Range)
};

class expr__Slice : public expr_t {
 public:
  expr__Slice()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Slice),
                      field_mask(), sizeof(expr__Slice)),
        lower(nullptr),
        upper(nullptr),
        spids(NewList<int>()) {
  }

  expr__Slice(expr_t* lower, expr_t* upper)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Slice),
                      field_mask(), sizeof(expr__Slice)),
        lower(lower),
        upper(upper),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* lower;
  expr_t* upper;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Slice, lower))
         | maskbit(offsetof(expr__Slice, upper))
         | maskbit(offsetof(expr__Slice, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Slice)
};

class expr__Spread : public expr_t {
 public:
  expr__Spread()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Spread),
                      field_mask(), sizeof(expr__Spread)),
        child(nullptr),
        ctx(expr_context_e::Load),
        spids(NewList<int>()) {
  }

  expr__Spread(expr_t* child, expr_context_t ctx)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(expr_e::Spread),
                      field_mask(), sizeof(expr__Spread)),
        child(child),
        ctx(ctx),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* child;
  expr_context_t ctx;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(expr__Spread, child))
         | maskbit(offsetof(expr__Spread, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(expr__Spread)
};

namespace expr {
  typedef expr__Var Var;
  typedef expr__Const Const;
  typedef expr__RegexLiteral RegexLiteral;
  typedef expr__BlockArg BlockArg;
  typedef expr__Lambda Lambda;
  typedef expr__Unary Unary;
  typedef expr__Binary Binary;
  typedef expr__Compare Compare;
  typedef expr__FuncCall FuncCall;
  typedef expr__IfExp IfExp;
  typedef expr__Tuple Tuple;
  typedef expr__List List;
  typedef expr__Dict Dict;
  typedef expr__Implicit Implicit;
  typedef expr__ListComp ListComp;
  typedef expr__DictComp DictComp;
  typedef expr__GeneratorExp GeneratorExp;
  typedef expr__Range Range;
  typedef expr__Slice Slice;
  typedef expr__Spread Spread;
}

namespace class_literal_term_e {
  const int PosixClass = 93;
  const int PerlClass = 94;
  const int Range = 3;
  const int CharLiteral = 4;
  const int SimpleVarSub = 69;
  const int BracedVarSub = 70;
  const int SingleQuoted = 68;
  const int DoubleQuoted = 67;
};

const char* class_literal_term_str(int tag);

class class_literal_term_t {
 protected:
  class_literal_term_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(class_literal_term_t)
};

class class_literal_term__Range : public class_literal_term_t {
 public:
  class_literal_term__Range()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_literal_term_e::Range),
                      field_mask(), sizeof(class_literal_term__Range)),
        start(nullptr),
        end(nullptr) {
  }

  class_literal_term__Range(Token* start, Token* end)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_literal_term_e::Range),
                      field_mask(), sizeof(class_literal_term__Range)),
        start(start),
        end(end) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* start;
  Token* end;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(class_literal_term__Range, start))
         | maskbit(offsetof(class_literal_term__Range, end));
  }

  DISALLOW_COPY_AND_ASSIGN(class_literal_term__Range)
};

class class_literal_term__CharLiteral : public class_literal_term_t {
 public:
  class_literal_term__CharLiteral()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_literal_term_e::CharLiteral),
                      field_mask(), sizeof(class_literal_term__CharLiteral)),
        tok(nullptr) {
  }

  class_literal_term__CharLiteral(Token* tok)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(class_literal_term_e::CharLiteral),
                      field_mask(), sizeof(class_literal_term__CharLiteral)),
        tok(tok) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* tok;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(class_literal_term__CharLiteral, tok));
  }

  DISALLOW_COPY_AND_ASSIGN(class_literal_term__CharLiteral)
};

namespace class_literal_term {
  typedef class_literal_term__Range Range;
  typedef class_literal_term__CharLiteral CharLiteral;
}

namespace char_class_term_e {
  const int PosixClass = 93;
  const int PerlClass = 94;
  const int Range = 3;
  const int CharCode = 95;
};

const char* char_class_term_str(int tag);

class char_class_term_t {
 protected:
  char_class_term_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(char_class_term_t)
};

class char_class_term__Range : public char_class_term_t {
 public:
  char_class_term__Range()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(char_class_term_e::Range),
                      field_mask(), sizeof(char_class_term__Range)),
        start(nullptr),
        end(nullptr) {
  }

  char_class_term__Range(CharCode* start, CharCode* end)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(char_class_term_e::Range),
                      field_mask(), sizeof(char_class_term__Range)),
        start(start),
        end(end) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  CharCode* start;
  CharCode* end;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(char_class_term__Range, start))
         | maskbit(offsetof(char_class_term__Range, end));
  }

  DISALLOW_COPY_AND_ASSIGN(char_class_term__Range)
};

namespace char_class_term {
  typedef char_class_term__Range Range;
}

namespace re_repeat_e {
  const int Op = 1;
  const int Num = 2;
  const int Range = 3;
};

const char* re_repeat_str(int tag);

class re_repeat_t {
 protected:
  re_repeat_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(re_repeat_t)
};

class re_repeat__Op : public re_repeat_t {
 public:
  re_repeat__Op()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Op),
                      field_mask(), sizeof(re_repeat__Op)),
        op(nullptr) {
  }

  re_repeat__Op(Token* op)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Op),
                      field_mask(), sizeof(re_repeat__Op)),
        op(op) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* op;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re_repeat__Op, op));
  }

  DISALLOW_COPY_AND_ASSIGN(re_repeat__Op)
};

class re_repeat__Num : public re_repeat_t {
 public:
  re_repeat__Num()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Num),
                      field_mask(), sizeof(re_repeat__Num)),
        times(nullptr) {
  }

  re_repeat__Num(Token* times)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Num),
                      field_mask(), sizeof(re_repeat__Num)),
        times(times) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* times;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re_repeat__Num, times));
  }

  DISALLOW_COPY_AND_ASSIGN(re_repeat__Num)
};

class re_repeat__Range : public re_repeat_t {
 public:
  re_repeat__Range()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Range),
                      field_mask(), sizeof(re_repeat__Range)),
        lower(nullptr),
        upper(nullptr) {
  }

  re_repeat__Range(Token* lower, Token* upper)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_repeat_e::Range),
                      field_mask(), sizeof(re_repeat__Range)),
        lower(lower),
        upper(upper) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* lower;
  Token* upper;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re_repeat__Range, lower))
         | maskbit(offsetof(re_repeat__Range, upper));
  }

  DISALLOW_COPY_AND_ASSIGN(re_repeat__Range)
};

namespace re_repeat {
  typedef re_repeat__Op Op;
  typedef re_repeat__Num Num;
  typedef re_repeat__Range Range;
}

namespace re_e {
  const int Speck = 66;
  const int Token = 65;
  const int PosixClass = 93;
  const int PerlClass = 94;
  const int CharClassLiteral = 5;
  const int CharClass = 6;
  const int Splice = 7;
  const int SimpleVarSub = 69;
  const int BracedVarSub = 70;
  const int SingleQuoted = 68;
  const int DoubleQuoted = 67;
  const int Repeat = 12;
  const int Seq = 13;
  const int Alt = 14;
  const int Group = 15;
  const int Capture = 16;
  const int Backtracking = 17;
  const int Primitive = 18;
  const int LiteralChars = 19;
};

const char* re_str(int tag);

class re_t {
 protected:
  re_t() {
  }
 public:
  int tag_() const {
    return reinterpret_cast<const ObjHeader*>(this)->type_tag;
  }
  hnode_t* PrettyTree();
  DISALLOW_COPY_AND_ASSIGN(re_t)
};

class re__CharClassLiteral : public re_t {
 public:
  re__CharClassLiteral()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::CharClassLiteral),
                      field_mask(), sizeof(re__CharClassLiteral)),
        negated(false),
        terms(NewList<class_literal_term_t*>()) {
  }

  re__CharClassLiteral(bool negated, List<class_literal_term_t*>* terms)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::CharClassLiteral),
                      field_mask(), sizeof(re__CharClassLiteral)),
        negated(negated),
        terms(terms) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool negated;
  List<class_literal_term_t*>* terms;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__CharClassLiteral, terms));
  }

  DISALLOW_COPY_AND_ASSIGN(re__CharClassLiteral)
};

class re__CharClass : public re_t {
 public:
  re__CharClass()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::CharClass),
                      field_mask(), sizeof(re__CharClass)),
        negated(false),
        terms(NewList<char_class_term_t*>()) {
  }

  re__CharClass(bool negated, List<char_class_term_t*>* terms)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::CharClass),
                      field_mask(), sizeof(re__CharClass)),
        negated(negated),
        terms(terms) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool negated;
  List<char_class_term_t*>* terms;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__CharClass, terms));
  }

  DISALLOW_COPY_AND_ASSIGN(re__CharClass)
};

class re__Splice : public re_t {
 public:
  re__Splice()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Splice),
                      field_mask(), sizeof(re__Splice)),
        name(nullptr) {
  }

  re__Splice(Token* name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Splice),
                      field_mask(), sizeof(re__Splice)),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Splice, name));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Splice)
};

class re__Repeat : public re_t {
 public:
  re__Repeat()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Repeat),
                      field_mask(), sizeof(re__Repeat)),
        child(nullptr),
        op(nullptr) {
  }

  re__Repeat(re_t* child, re_repeat_t* op)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Repeat),
                      field_mask(), sizeof(re__Repeat)),
        child(child),
        op(op) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  re_t* child;
  re_repeat_t* op;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Repeat, child))
         | maskbit(offsetof(re__Repeat, op));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Repeat)
};

class re__Seq : public re_t {
 public:
  re__Seq()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Seq),
                      field_mask(), sizeof(re__Seq)),
        children(NewList<re_t*>()) {
  }

  re__Seq(List<re_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Seq),
                      field_mask(), sizeof(re__Seq)),
        children(children) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<re_t*>* children;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Seq, children));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Seq)
};

class re__Alt : public re_t {
 public:
  re__Alt()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Alt),
                      field_mask(), sizeof(re__Alt)),
        children(NewList<re_t*>()) {
  }

  re__Alt(List<re_t*>* children)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Alt),
                      field_mask(), sizeof(re__Alt)),
        children(children) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<re_t*>* children;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Alt, children));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Alt)
};

class re__Group : public re_t {
 public:
  re__Group()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Group),
                      field_mask(), sizeof(re__Group)),
        child(nullptr) {
  }

  re__Group(re_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Group),
                      field_mask(), sizeof(re__Group)),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  re_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Group, child));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Group)
};

class re__Capture : public re_t {
 public:
  re__Capture()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Capture),
                      field_mask(), sizeof(re__Capture)),
        child(nullptr),
        var_name(nullptr) {
  }

  re__Capture(re_t* child, Token* var_name)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Capture),
                      field_mask(), sizeof(re__Capture)),
        child(child),
        var_name(var_name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  re_t* child;
  Token* var_name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Capture, child))
         | maskbit(offsetof(re__Capture, var_name));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Capture)
};

class re__Backtracking : public re_t {
 public:
  re__Backtracking()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Backtracking),
                      field_mask(), sizeof(re__Backtracking)),
        negated(false),
        name(nullptr),
        child(nullptr) {
  }

  re__Backtracking(bool negated, Token* name, re_t* child)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Backtracking),
                      field_mask(), sizeof(re__Backtracking)),
        negated(negated),
        name(name),
        child(child) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  bool negated;
  Token* name;
  re_t* child;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__Backtracking, name))
         | maskbit(offsetof(re__Backtracking, child));
  }

  DISALLOW_COPY_AND_ASSIGN(re__Backtracking)
};

class re__Primitive : public re_t {
 public:
  re__Primitive()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Primitive),
                      kZeroMask, sizeof(re__Primitive)),
        id(-1) {
  }

  re__Primitive(Id_t id)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::Primitive),
                      kZeroMask, sizeof(re__Primitive)),
        id(id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t id;

  DISALLOW_COPY_AND_ASSIGN(re__Primitive)
};

class re__LiteralChars : public re_t {
 public:
  re__LiteralChars()
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::LiteralChars),
                      field_mask(), sizeof(re__LiteralChars)),
        s(StrFromC("")),
        spid(-1) {
  }

  re__LiteralChars(Str* s, int spid)
      : GC_ASDL_CLASS(header_, static_cast<uint16_t>(re_e::LiteralChars),
                      field_mask(), sizeof(re__LiteralChars)),
        s(s),
        spid(spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* s;
  int spid;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(re__LiteralChars, s));
  }

  DISALLOW_COPY_AND_ASSIGN(re__LiteralChars)
};

namespace re {
  typedef re__CharClassLiteral CharClassLiteral;
  typedef re__CharClass CharClass;
  typedef re__Splice Splice;
  typedef re__Repeat Repeat;
  typedef re__Seq Seq;
  typedef re__Alt Alt;
  typedef re__Group Group;
  typedef re__Capture Capture;
  typedef re__Backtracking Backtracking;
  typedef re__Primitive Primitive;
  typedef re__LiteralChars LiteralChars;
}

class line_span {
 public:
  line_span()
      : GC_ASDL_CLASS(header_, 64,
                      kZeroMask, sizeof(line_span)),
        line_id(-1),
        col(-1),
        length(-1) {
  }

  line_span(int line_id, int col, int length)
      : GC_ASDL_CLASS(header_, 64,
                      kZeroMask, sizeof(line_span)),
        line_id(line_id),
        col(col),
        length(length) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int line_id;
  int col;
  int length;

  DISALLOW_COPY_AND_ASSIGN(line_span)
};

class Token : public suffix_op_t, public word_part_t, public word_t, public
arith_expr_t, public re_t {
 public:
  Token()
      : GC_ASDL_CLASS(header_, 65,
                      field_mask(), sizeof(Token)),
        id(-1),
        span_id(-1),
        val(StrFromC("")) {
  }

  Token(Id_t id, int span_id, Str* val)
      : GC_ASDL_CLASS(header_, 65,
                      field_mask(), sizeof(Token)),
        id(id),
        span_id(span_id),
        val(val) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t id;
  int span_id;
  Str* val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(Token, val));
  }

  DISALLOW_COPY_AND_ASSIGN(Token)
};

class speck : public re_t {
 public:
  speck()
      : GC_ASDL_CLASS(header_, 66,
                      kZeroMask, sizeof(speck)),
        id(-1),
        span_id(-1) {
  }

  speck(Id_t id, int span_id)
      : GC_ASDL_CLASS(header_, 66,
                      kZeroMask, sizeof(speck)),
        id(id),
        span_id(span_id) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Id_t id;
  int span_id;

  DISALLOW_COPY_AND_ASSIGN(speck)
};

class double_quoted : public word_part_t, public expr_t, public
class_literal_term_t, public re_t {
 public:
  double_quoted()
      : GC_ASDL_CLASS(header_, 67,
                      field_mask(), sizeof(double_quoted)),
        left(nullptr),
        parts(NewList<word_part_t*>()),
        multiline(false),
        spids(NewList<int>()) {
  }

  double_quoted(Token* left, List<word_part_t*>* parts, bool multiline)
      : GC_ASDL_CLASS(header_, 67,
                      field_mask(), sizeof(double_quoted)),
        left(left),
        parts(parts),
        multiline(multiline),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  List<word_part_t*>* parts;
  bool multiline;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(double_quoted, left))
         | maskbit(offsetof(double_quoted, parts))
         | maskbit(offsetof(double_quoted, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(double_quoted)
};

class single_quoted : public word_part_t, public expr_t, public
class_literal_term_t, public re_t {
 public:
  single_quoted()
      : GC_ASDL_CLASS(header_, 68,
                      field_mask(), sizeof(single_quoted)),
        left(nullptr),
        tokens(NewList<Token*>()),
        multiline(false),
        spids(NewList<int>()) {
  }

  single_quoted(Token* left, List<Token*>* tokens, bool multiline)
      : GC_ASDL_CLASS(header_, 68,
                      field_mask(), sizeof(single_quoted)),
        left(left),
        tokens(tokens),
        multiline(multiline),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  List<Token*>* tokens;
  bool multiline;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(single_quoted, left))
         | maskbit(offsetof(single_quoted, tokens))
         | maskbit(offsetof(single_quoted, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(single_quoted)
};

class simple_var_sub : public word_part_t, public expr_t, public
class_literal_term_t, public re_t {
 public:
  simple_var_sub()
      : GC_ASDL_CLASS(header_, 69,
                      field_mask(), sizeof(simple_var_sub)),
        token(nullptr) {
  }

  simple_var_sub(Token* token)
      : GC_ASDL_CLASS(header_, 69,
                      field_mask(), sizeof(simple_var_sub)),
        token(token) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(simple_var_sub, token));
  }

  DISALLOW_COPY_AND_ASSIGN(simple_var_sub)
};

class braced_var_sub : public word_part_t, public expr_t, public
class_literal_term_t, public re_t {
 public:
  braced_var_sub()
      : GC_ASDL_CLASS(header_, 70,
                      field_mask(), sizeof(braced_var_sub)),
        token(nullptr),
        prefix_op(nullptr),
        bracket_op(nullptr),
        suffix_op(nullptr),
        spids(NewList<int>()) {
  }

  braced_var_sub(Token* token, speck* prefix_op, bracket_op_t* bracket_op,
                 suffix_op_t* suffix_op)
      : GC_ASDL_CLASS(header_, 70,
                      field_mask(), sizeof(braced_var_sub)),
        token(token),
        prefix_op(prefix_op),
        bracket_op(bracket_op),
        suffix_op(suffix_op),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* token;
  speck* prefix_op;
  bracket_op_t* bracket_op;
  suffix_op_t* suffix_op;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(braced_var_sub, token))
         | maskbit(offsetof(braced_var_sub, prefix_op))
         | maskbit(offsetof(braced_var_sub, bracket_op))
         | maskbit(offsetof(braced_var_sub, suffix_op))
         | maskbit(offsetof(braced_var_sub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(braced_var_sub)
};

class command_sub : public word_part_t, public expr_t {
 public:
  command_sub()
      : GC_ASDL_CLASS(header_, 71,
                      field_mask(), sizeof(command_sub)),
        left_token(nullptr),
        child(nullptr),
        spids(NewList<int>()) {
  }

  command_sub(Token* left_token, command_t* child)
      : GC_ASDL_CLASS(header_, 71,
                      field_mask(), sizeof(command_sub)),
        left_token(left_token),
        child(child),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left_token;
  command_t* child;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(command_sub, left_token))
         | maskbit(offsetof(command_sub, child))
         | maskbit(offsetof(command_sub, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(command_sub)
};

class sh_array_literal : public word_part_t, public expr_t {
 public:
  sh_array_literal()
      : GC_ASDL_CLASS(header_, 72,
                      field_mask(), sizeof(sh_array_literal)),
        left(nullptr),
        words(NewList<word_t*>()),
        spids(NewList<int>()) {
  }

  sh_array_literal(Token* left, List<word_t*>* words)
      : GC_ASDL_CLASS(header_, 72,
                      field_mask(), sizeof(sh_array_literal)),
        left(left),
        words(words),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* left;
  List<word_t*>* words;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(sh_array_literal, left))
         | maskbit(offsetof(sh_array_literal, words))
         | maskbit(offsetof(sh_array_literal, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(sh_array_literal)
};

class ArgList {
 public:
  ArgList()
      : GC_ASDL_CLASS(header_, 73,
                      field_mask(), sizeof(ArgList)),
        positional(NewList<expr_t*>()),
        named(NewList<named_arg*>()),
        spids(NewList<int>()) {
  }

  ArgList(List<expr_t*>* positional, List<named_arg*>* named)
      : GC_ASDL_CLASS(header_, 73,
                      field_mask(), sizeof(ArgList)),
        positional(positional),
        named(named),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<expr_t*>* positional;
  List<named_arg*>* named;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(ArgList, positional))
         | maskbit(offsetof(ArgList, named))
         | maskbit(offsetof(ArgList, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(ArgList)
};

class compound_word : public word_t, public arith_expr_t, public redir_param_t {
 public:
  compound_word()
      : GC_ASDL_CLASS(header_, 74,
                      field_mask(), sizeof(compound_word)),
        parts(NewList<word_part_t*>()) {
  }

  compound_word(List<word_part_t*>* parts)
      : GC_ASDL_CLASS(header_, 74,
                      field_mask(), sizeof(compound_word)),
        parts(parts) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<word_part_t*>* parts;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(compound_word, parts));
  }

  DISALLOW_COPY_AND_ASSIGN(compound_word)
};

class string_line {
 public:
  string_line()
      : GC_ASDL_CLASS(header_, 75,
                      field_mask(), sizeof(string_line)),
        dedent(-1),
        part(NewList<word_part_t*>()) {
  }

  string_line(int dedent, List<word_part_t*>* part)
      : GC_ASDL_CLASS(header_, 75,
                      field_mask(), sizeof(string_line)),
        dedent(dedent),
        part(part) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int dedent;
  List<word_part_t*>* part;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(string_line, part));
  }

  DISALLOW_COPY_AND_ASSIGN(string_line)
};

class triple_quoted {
 public:
  triple_quoted()
      : GC_ASDL_CLASS(header_, 76,
                      field_mask(), sizeof(triple_quoted)),
        min_dedent(-1),
        lines(NewList<string_line*>()) {
  }

  triple_quoted(int min_dedent, List<string_line*>* lines)
      : GC_ASDL_CLASS(header_, 76,
                      field_mask(), sizeof(triple_quoted)),
        min_dedent(min_dedent),
        lines(lines) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int min_dedent;
  List<string_line*>* lines;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(triple_quoted, lines));
  }

  DISALLOW_COPY_AND_ASSIGN(triple_quoted)
};

class redir {
 public:
  redir()
      : GC_ASDL_CLASS(header_, 77,
                      field_mask(), sizeof(redir)),
        op(nullptr),
        loc(nullptr),
        arg(nullptr) {
  }

  redir(Token* op, redir_loc_t* loc, redir_param_t* arg)
      : GC_ASDL_CLASS(header_, 77,
                      field_mask(), sizeof(redir)),
        op(op),
        loc(loc),
        arg(arg) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* op;
  redir_loc_t* loc;
  redir_param_t* arg;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(redir, op))
         | maskbit(offsetof(redir, loc))
         | maskbit(offsetof(redir, arg));
  }

  DISALLOW_COPY_AND_ASSIGN(redir)
};

class assign_pair {
 public:
  assign_pair()
      : GC_ASDL_CLASS(header_, 78,
                      field_mask(), sizeof(assign_pair)),
        lhs(nullptr),
        op(assign_op_e::Equal),
        rhs(nullptr),
        spids(NewList<int>()) {
  }

  assign_pair(sh_lhs_expr_t* lhs, assign_op_t op, word_t* rhs, List<int>* spids)
      : GC_ASDL_CLASS(header_, 78,
                      field_mask(), sizeof(assign_pair)),
        lhs(lhs),
        op(op),
        rhs(rhs),
        spids(spids) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  sh_lhs_expr_t* lhs;
  assign_op_t op;
  word_t* rhs;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(assign_pair, lhs))
         | maskbit(offsetof(assign_pair, rhs))
         | maskbit(offsetof(assign_pair, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(assign_pair)
};

class env_pair {
 public:
  env_pair()
      : GC_ASDL_CLASS(header_, 79,
                      field_mask(), sizeof(env_pair)),
        name(StrFromC("")),
        val(nullptr),
        spids(NewList<int>()) {
  }

  env_pair(Str* name, word_t* val, List<int>* spids)
      : GC_ASDL_CLASS(header_, 79,
                      field_mask(), sizeof(env_pair)),
        name(name),
        val(val),
        spids(spids) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Str* name;
  word_t* val;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(env_pair, name))
         | maskbit(offsetof(env_pair, val))
         | maskbit(offsetof(env_pair, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(env_pair)
};

class case_arm {
 public:
  case_arm()
      : GC_ASDL_CLASS(header_, 80,
                      field_mask(), sizeof(case_arm)),
        pat_list(NewList<word_t*>()),
        action(NewList<command_t*>()),
        spids(NewList<int>()) {
  }

  case_arm(List<word_t*>* pat_list, List<command_t*>* action, List<int>* spids)
      : GC_ASDL_CLASS(header_, 80,
                      field_mask(), sizeof(case_arm)),
        pat_list(pat_list),
        action(action),
        spids(spids) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<word_t*>* pat_list;
  List<command_t*>* action;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(case_arm, pat_list))
         | maskbit(offsetof(case_arm, action))
         | maskbit(offsetof(case_arm, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(case_arm)
};

class if_arm {
 public:
  if_arm()
      : GC_ASDL_CLASS(header_, 81,
                      field_mask(), sizeof(if_arm)),
        cond(nullptr),
        action(NewList<command_t*>()),
        spids(NewList<int>()) {
  }

  if_arm(condition_t* cond, List<command_t*>* action, List<int>* spids)
      : GC_ASDL_CLASS(header_, 81,
                      field_mask(), sizeof(if_arm)),
        cond(cond),
        action(action),
        spids(spids) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  condition_t* cond;
  List<command_t*>* action;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(if_arm, cond))
         | maskbit(offsetof(if_arm, action))
         | maskbit(offsetof(if_arm, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(if_arm)
};

class BraceGroup : public command_t {
 public:
  BraceGroup()
      : GC_ASDL_CLASS(header_, 82,
                      field_mask(), sizeof(BraceGroup)),
        doc_token(nullptr),
        children(NewList<command_t*>()),
        redirects(NewList<redir*>()),
        spids(NewList<int>()) {
  }

  BraceGroup(Token* doc_token, List<command_t*>* children, List<redir*>*
             redirects)
      : GC_ASDL_CLASS(header_, 82,
                      field_mask(), sizeof(BraceGroup)),
        doc_token(doc_token),
        children(children),
        redirects(redirects),
        spids(NewList<int>()) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* doc_token;
  List<command_t*>* children;
  List<redir*>* redirects;
  List<int>* spids;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(BraceGroup, doc_token))
         | maskbit(offsetof(BraceGroup, children))
         | maskbit(offsetof(BraceGroup, redirects))
         | maskbit(offsetof(BraceGroup, spids));
  }

  DISALLOW_COPY_AND_ASSIGN(BraceGroup)
};

class variant {
 public:
  variant()
      : GC_ASDL_CLASS(header_, 83,
                      field_mask(), sizeof(variant)),
        tag_name(nullptr),
        typ(nullptr) {
  }

  variant(Token* tag_name, variant_type_t* typ)
      : GC_ASDL_CLASS(header_, 83,
                      field_mask(), sizeof(variant)),
        tag_name(tag_name),
        typ(typ) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* tag_name;
  variant_type_t* typ;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(variant, tag_name))
         | maskbit(offsetof(variant, typ));
  }

  DISALLOW_COPY_AND_ASSIGN(variant)
};

class import_name {
 public:
  import_name()
      : GC_ASDL_CLASS(header_, 84,
                      field_mask(), sizeof(import_name)),
        name(nullptr),
        alias(nullptr) {
  }

  import_name(Token* name, Token* alias)
      : GC_ASDL_CLASS(header_, 84,
                      field_mask(), sizeof(import_name)),
        name(name),
        alias(alias) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  Token* alias;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(import_name, name))
         | maskbit(offsetof(import_name, alias));
  }

  DISALLOW_COPY_AND_ASSIGN(import_name)
};

class UntypedParam {
 public:
  UntypedParam()
      : GC_ASDL_CLASS(header_, 85,
                      field_mask(), sizeof(UntypedParam)),
        ref(nullptr),
        name(nullptr),
        default_val(nullptr) {
  }

  UntypedParam(Token* ref, Token* name, expr_t* default_val)
      : GC_ASDL_CLASS(header_, 85,
                      field_mask(), sizeof(UntypedParam)),
        ref(ref),
        name(name),
        default_val(default_val) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* ref;
  Token* name;
  expr_t* default_val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(UntypedParam, ref))
         | maskbit(offsetof(UntypedParam, name))
         | maskbit(offsetof(UntypedParam, default_val));
  }

  DISALLOW_COPY_AND_ASSIGN(UntypedParam)
};

class TypedParam {
 public:
  TypedParam()
      : GC_ASDL_CLASS(header_, 86,
                      field_mask(), sizeof(TypedParam)),
        name(nullptr),
        type(nullptr),
        default_val(nullptr) {
  }

  TypedParam(Token* name, Token* type, expr_t* default_val)
      : GC_ASDL_CLASS(header_, 86,
                      field_mask(), sizeof(TypedParam)),
        name(name),
        type(type),
        default_val(default_val) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  Token* type;
  expr_t* default_val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(TypedParam, name))
         | maskbit(offsetof(TypedParam, type))
         | maskbit(offsetof(TypedParam, default_val));
  }

  DISALLOW_COPY_AND_ASSIGN(TypedParam)
};

class param {
 public:
  param()
      : GC_ASDL_CLASS(header_, 87,
                      field_mask(), sizeof(param)),
        prefix(nullptr),
        name(nullptr),
        type(nullptr),
        default_val(nullptr) {
  }

  param(Token* prefix, Token* name, type_expr_t* type, expr_t* default_val)
      : GC_ASDL_CLASS(header_, 87,
                      field_mask(), sizeof(param)),
        prefix(prefix),
        name(name),
        type(type),
        default_val(default_val) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* prefix;
  Token* name;
  type_expr_t* type;
  expr_t* default_val;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(param, prefix))
         | maskbit(offsetof(param, name))
         | maskbit(offsetof(param, type))
         | maskbit(offsetof(param, default_val));
  }

  DISALLOW_COPY_AND_ASSIGN(param)
};

class name_type {
 public:
  name_type()
      : GC_ASDL_CLASS(header_, 88,
                      field_mask(), sizeof(name_type)),
        name(nullptr),
        typ(nullptr) {
  }

  name_type(Token* name, type_expr_t* typ)
      : GC_ASDL_CLASS(header_, 88,
                      field_mask(), sizeof(name_type)),
        name(name),
        typ(typ) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  type_expr_t* typ;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(name_type, name))
         | maskbit(offsetof(name_type, typ));
  }

  DISALLOW_COPY_AND_ASSIGN(name_type)
};

class comprehension {
 public:
  comprehension()
      : GC_ASDL_CLASS(header_, 89,
                      field_mask(), sizeof(comprehension)),
        lhs(NewList<name_type*>()),
        iter(nullptr),
        cond(nullptr) {
  }

  comprehension(List<name_type*>* lhs, expr_t* iter, expr_t* cond)
      : GC_ASDL_CLASS(header_, 89,
                      field_mask(), sizeof(comprehension)),
        lhs(lhs),
        iter(iter),
        cond(cond) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  List<name_type*>* lhs;
  expr_t* iter;
  expr_t* cond;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(comprehension, lhs))
         | maskbit(offsetof(comprehension, iter))
         | maskbit(offsetof(comprehension, cond));
  }

  DISALLOW_COPY_AND_ASSIGN(comprehension)
};

class named_arg {
 public:
  named_arg()
      : GC_ASDL_CLASS(header_, 90,
                      field_mask(), sizeof(named_arg)),
        name(nullptr),
        value(nullptr) {
  }

  named_arg(Token* name, expr_t* value)
      : GC_ASDL_CLASS(header_, 90,
                      field_mask(), sizeof(named_arg)),
        name(name),
        value(value) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  Token* name;
  expr_t* value;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(named_arg, name))
         | maskbit(offsetof(named_arg, value));
  }

  DISALLOW_COPY_AND_ASSIGN(named_arg)
};

class subscript : public place_expr_t, public expr_t {
 public:
  subscript()
      : GC_ASDL_CLASS(header_, 91,
                      field_mask(), sizeof(subscript)),
        obj(nullptr),
        indices(NewList<expr_t*>()) {
  }

  subscript(expr_t* obj, List<expr_t*>* indices)
      : GC_ASDL_CLASS(header_, 91,
                      field_mask(), sizeof(subscript)),
        obj(obj),
        indices(indices) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* obj;
  List<expr_t*>* indices;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(subscript, obj))
         | maskbit(offsetof(subscript, indices));
  }

  DISALLOW_COPY_AND_ASSIGN(subscript)
};

class attribute : public place_expr_t, public expr_t {
 public:
  attribute()
      : GC_ASDL_CLASS(header_, 92,
                      field_mask(), sizeof(attribute)),
        obj(nullptr),
        op(nullptr),
        attr(nullptr),
        ctx(expr_context_e::Load) {
  }

  attribute(expr_t* obj, Token* op, Token* attr, expr_context_t ctx)
      : GC_ASDL_CLASS(header_, 92,
                      field_mask(), sizeof(attribute)),
        obj(obj),
        op(op),
        attr(attr),
        ctx(ctx) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  expr_t* obj;
  Token* op;
  Token* attr;
  expr_context_t ctx;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(attribute, obj))
         | maskbit(offsetof(attribute, op))
         | maskbit(offsetof(attribute, attr));
  }

  DISALLOW_COPY_AND_ASSIGN(attribute)
};

class posix_class : public class_literal_term_t, public char_class_term_t,
public re_t {
 public:
  posix_class()
      : GC_ASDL_CLASS(header_, 93,
                      field_mask(), sizeof(posix_class)),
        negated(nullptr),
        name(StrFromC("")) {
  }

  posix_class(speck* negated, Str* name)
      : GC_ASDL_CLASS(header_, 93,
                      field_mask(), sizeof(posix_class)),
        negated(negated),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  speck* negated;
  Str* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(posix_class, negated))
         | maskbit(offsetof(posix_class, name));
  }

  DISALLOW_COPY_AND_ASSIGN(posix_class)
};

class perl_class : public class_literal_term_t, public char_class_term_t,
public re_t {
 public:
  perl_class()
      : GC_ASDL_CLASS(header_, 94,
                      field_mask(), sizeof(perl_class)),
        negated(nullptr),
        name(StrFromC("")) {
  }

  perl_class(speck* negated, Str* name)
      : GC_ASDL_CLASS(header_, 94,
                      field_mask(), sizeof(perl_class)),
        negated(negated),
        name(name) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  speck* negated;
  Str* name;

  static constexpr uint16_t field_mask() {
    return maskbit(offsetof(perl_class, negated))
         | maskbit(offsetof(perl_class, name));
  }

  DISALLOW_COPY_AND_ASSIGN(perl_class)
};

class CharCode : public char_class_term_t {
 public:
  CharCode()
      : GC_ASDL_CLASS(header_, 95,
                      kZeroMask, sizeof(CharCode)),
        i(-1),
        u_braced(false),
        spid(-1) {
  }

  CharCode(int i, bool u_braced, int spid)
      : GC_ASDL_CLASS(header_, 95,
                      kZeroMask, sizeof(CharCode)),
        i(i),
        u_braced(u_braced),
        spid(spid) {
  }

  hnode_t* PrettyTree();

  GC_OBJ(header_);
  int i;
  bool u_braced;
  int spid;

  DISALLOW_COPY_AND_ASSIGN(CharCode)
};


}  // namespace syntax_asdl

#endif  // SYNTAX_ASDL
